class
	S_STDIO_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public routines

	fprintf (a_args: TUPLE [a_stream: CE_POINTER [SD_IO_FILE]; a_format: CE_POINTER [INTEGER_8]]): INTEGER_32
		do
			Result := (create {CE_ROUTINE}.make_shared (c_fprintf)).integer_32_item (a_args)
		end

	c_fprintf: POINTER
		external
			"C inline use <libmongo.h>"
		alias
			"return (EIF_POINTER)&fprintf;"
		end

	printf (a_args: TUPLE [a_format: CE_POINTER [INTEGER_8]]): INTEGER_32
		do
			Result := (create {CE_ROUTINE}.make_shared (c_printf)).integer_32_item (a_args)
		end

	c_printf: POINTER
		external
			"C inline use <libmongo.h>"
		alias
			"return (EIF_POINTER)&printf;"
		end

	sprintf (a_args: TUPLE [a_s, a_format: CE_POINTER [INTEGER_8]]): INTEGER_32
		do
			Result := (create {CE_ROUTINE}.make_shared (c_sprintf)).integer_32_item (a_args)
		end

	c_sprintf: POINTER
		external
			"C inline use <libmongo.h>"
		alias
			"return (EIF_POINTER)&sprintf;"
		end

	vfprintf (a_s: CE_POINTER [SD_IO_FILE]; a_format: CE_POINTER [INTEGER_8]; a_arg: CE_VA_LIST): INTEGER_32
		do
			Result := c_vfprintf (a_s.c_pointer, a_format.c_pointer, a_arg.c_pointer)
		end

	c_vfprintf (a_s: POINTER; a_format: POINTER; a_arg: POINTER): INTEGER_32
		external
			"C inline use <libmongo.h>"
		alias
			"return vfprintf($a_s, $a_format, $a_arg);"
		end

	fclose (a_stream: CE_POINTER [SD_IO_FILE]): INTEGER_32
		do
			Result := c_fclose (a_stream.c_pointer)
		end

	c_fclose (a_stream: POINTER): INTEGER_32
		external
			"C inline use <libmongo.h>"
		alias
			"return fclose($a_stream);"
		end

	fopen (a_filename, a_modes: CE_POINTER [INTEGER_8]): CE_POINTER [SD_IO_FILE]
		do
			create {CE_CLASS_POINTER [SD_IO_FILE]} Result.make_shared (c_fopen (a_filename.c_pointer, a_modes.c_pointer))
		end

	c_fopen (a_filename: POINTER; a_modes: POINTER): POINTER
		external
			"C inline use <libmongo.h>"
		alias
			"return (EIF_POINTER)fopen($a_filename, $a_modes);"
		end

	fread (a_ptr: CE_POINTER [ANY]; a_size, a_n: NATURAL_32; a_stream: CE_POINTER [SD_IO_FILE]): NATURAL_32
		do
			Result := c_fread (a_ptr.c_pointer, a_size, a_n, a_stream.c_pointer)
		end

	c_fread (a_ptr: POINTER; a_size: NATURAL_32; a_n: NATURAL_32; a_stream: POINTER): NATURAL_32
		external
			"C inline use <libmongo.h>"
		alias
			"return fread($a_ptr, $a_size, $a_n, $a_stream);"
		end

	fwrite (a_ptr: CE_POINTER [ANY]; a_size, a_n: NATURAL_32; a_s: CE_POINTER [SD_IO_FILE]): NATURAL_32
		do
			Result := c_fwrite (a_ptr.c_pointer, a_size, a_n, a_s.c_pointer)
		end

	c_fwrite (a_ptr: POINTER; a_size: NATURAL_32; a_n: NATURAL_32; a_s: POINTER): NATURAL_32
		external
			"C inline use <libmongo.h>"
		alias
			"return fwrite($a_ptr, $a_size, $a_n, $a_s);"
		end

feature {ANY} -- routine addresses

	fprintf_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_shared (c_fprintf)
		end

	printf_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_shared (c_printf)
		end

	sprintf_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_shared (c_sprintf)
		end

end
