class
	S_STRING_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public routines

	memcpy (a_dest, a_src: CE_POINTER [ANY]; a_n: NATURAL_32): CE_POINTER [ANY]
		require
			a_n > 0 implies (not a_dest.is_void and not a_src.is_void)
		do
			create {CE_VOID_POINTER} Result.make_shared (c_memcpy (a_dest.c_pointer, a_src.c_pointer, a_n))
		end

	c_memcpy (a_dest: POINTER; a_src: POINTER; a_n: NATURAL_32): POINTER
		external
			"C inline use <libmongo.h>"
		alias
			"return (EIF_POINTER)memcpy($a_dest, $a_src, $a_n);"
		end

	memset (a_s: CE_POINTER [ANY]; a_c: INTEGER_32; a_n: NATURAL_32): CE_POINTER [ANY]
		require
			not a_s.is_void
		do
			create {CE_VOID_POINTER} Result.make_shared (c_memset (a_s.c_pointer, a_c, a_n))
		end

	strchr (a_str: CE_POINTER [INTEGER_8]; a_val: INTEGER_32): CE_POINTER [INTEGER_8]
		do
			create {CE_INTEGER_8_POINTER} Result.make_shared (c_strchr (a_str.c_pointer, a_val))
		end

	c_strchr (a_str: POINTER; a_val: INTEGER_32): POINTER
		external
			"C inline use <libmongo.h>"
		alias
			"return (EIF_POINTER)strchr($a_str, $a_val);"
		end

	strncpy (a_dest, a_source: CE_POINTER [INTEGER_8]; a_count: NATURAL_32): CE_POINTER [INTEGER_8]
		do
			create {CE_INTEGER_8_POINTER} Result.make_shared (c_strncpy (a_dest.c_pointer, a_source.c_pointer, a_count))
		end

	c_strncpy (a_dest: POINTER; a_source: POINTER; a_count: NATURAL_32): POINTER
		external
			"C inline use <libmongo.h>"
		alias
			"return (EIF_POINTER)strncpy($a_dest, $a_source, $a_count);"
		end

	c_memset (a_s: POINTER; a_c: INTEGER_32; a_n: NATURAL_32): POINTER
		external
			"C inline use <libmongo.h>"
		alias
			"return (EIF_POINTER)memset($a_s, $a_c, $a_n);"
		end

	strlen (a_s: CE_POINTER [INTEGER_8]): NATURAL_32
		require
			not a_s.is_void
		do
			Result := c_strlen (a_s.c_pointer)
		end

	c_strlen (a_s: POINTER): NATURAL_32
		external
			"C inline use <libmongo.h>"
		alias
			"return strlen($a_s);"
		end

	strcmp (a_str1, a_str2: CE_POINTER [INTEGER_8]): INTEGER_32
		do
			Result := c_strcmp (a_str1.c_pointer, a_str2.c_pointer)
		end

	c_strcmp (a_str1: POINTER; a_str2: POINTER): INTEGER_32
		external
			"C inline use <libmongo.h>"
		alias
			"return strcmp($a_str1, $a_str2);"
		end

	strcpy (a_dest, a_src: CE_POINTER [INTEGER_8]): CE_POINTER [INTEGER_8]
		require
			not a_dest.is_void
			not a_src.is_void
		do
			create {CE_INTEGER_8_POINTER} Result.make_shared (c_strcpy (a_dest.c_pointer, a_src.c_pointer))
		end

	c_strcpy (a_dest: POINTER; a_src: POINTER): POINTER
		external
			"C inline use <libmongo.h>"
		alias
			"return (EIF_POINTER)strcpy($a_dest, $a_src);"
		end

	strcat (a_dest, a_src: CE_POINTER [INTEGER_8]): CE_POINTER [INTEGER_8]
		require
			not a_dest.is_void
			not a_src.is_void
		do
			create {CE_INTEGER_8_POINTER} Result.make_shared (c_strcat (a_dest.c_pointer, a_src.c_pointer))
		end

	c_strcat (a_dest: POINTER; a_src: POINTER): POINTER
		external
			"C inline use <libmongo.h>"
		alias
			"return (EIF_POINTER)strcat($a_dest, $a_src);"
		end

	strerror (a_errnum: INTEGER_32): CE_POINTER [INTEGER_8]
		do
			create {CE_INTEGER_8_POINTER} Result.make_shared (c_strerror (a_errnum))
		end

	c_strerror (a_errnum: INTEGER_32): POINTER
		external
			"C inline use <libmongo.h>"
		alias
			"return (EIF_POINTER)strerror($a_errnum);"
		end

end
