class
	SD_CMSGHDR

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			make_shared,
			structure_size,
			offset_of,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			internal_c_pointer := internal_c_pointer.memory_alloc (structure_size)
			is_allocated_memory := True
		end

	make_shared (a_c_pointer: POINTER)
		do
			internal_c_pointer := a_c_pointer
		end

	make_initialized (a_data: TUPLE [
				a_cmsg_len: NATURAL_32
				a_cmsg_level: INTEGER_32
				a_cmsg_type: INTEGER_32
				a_cmsg_data: CE_ARRAY [NATURAL_8]
			])
		require else
			a_data /= Void
		do
			make
			Current.cmsg_len := a_data.a_cmsg_len
			Current.cmsg_level := a_data.a_cmsg_level
			Current.cmsg_type := a_data.a_cmsg_type
			cmsg_data.c_pointer.memory_copy (a_data.a_cmsg_data.c_pointer, a_data.a_cmsg_data.total_count * a_data.a_cmsg_data.element_size)
		end

feature {ANY} -- fields

	cmsg_len: NATURAL_32 assign set__cmsg_len
		do
			Result := c__cmsg_len (internal_c_pointer)
		end

	cmsg_level: INTEGER_32 assign set__cmsg_level
		do
			Result := c__cmsg_level (internal_c_pointer)
		end

	cmsg_type: INTEGER_32 assign set__cmsg_type
		do
			Result := c__cmsg_type (internal_c_pointer)
		end

	cmsg_data: CE_ARRAY [NATURAL_8]
		once ("OBJECT")
			create {CE_NATURAL_8_ARRAY} Result.make_shared (c__cmsg_data (internal_c_pointer), <<0>>)
		end

feature {ANY} -- field setters

	set__cmsg_len (a_cmsg_len: NATURAL_32)
		do
			c__set_cmsg_len (internal_c_pointer, a_cmsg_len)
		end

	set__cmsg_level (a_cmsg_level: INTEGER_32)
		do
			c__set_cmsg_level (internal_c_pointer, a_cmsg_level)
		end

	set__cmsg_type (a_cmsg_type: INTEGER_32)
		do
			c__set_cmsg_type (internal_c_pointer, a_cmsg_type)
		end

feature {ANY}

	structure_size: INTEGER_32
		external
			"C inline use %"libmongo.h%""
		alias
			"return sizeof(struct cmsghdr);"
		end

	structure_alignment: INTEGER_32
		external
			"C inline use %"libmongo.h%""
		alias
			"return __alignof__(struct cmsghdr);"
		end

	offset_of (a_field_name: STRING_8): INTEGER_32
		local
			l_c_str: C_STRING
		do
			create l_c_str.make (a_field_name)
			Result := c__offset_of (l_c_str.item)
		end

feature {ANY}

	copy (a_other: like Current)
		do
			make
			internal_c_pointer.memory_copy (a_other.c_pointer, structure_size)
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result := internal_c_pointer.memory_compare (a_other.c_pointer, structure_size)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		do
			-- dummy for CE_CLASS invariant
			create Result.make_struct (<<>>)
			Result.alignment := structure_alignment
		end

	c__cmsg_len (a_c_pointer: POINTER): NATURAL_32
		external
			"C inline use %"libmongo.h%""
		alias
			"return ((struct cmsghdr *)$a_c_pointer)->cmsg_len;"
		end

	c__cmsg_level (a_c_pointer: POINTER): INTEGER_32
		external
			"C inline use %"libmongo.h%""
		alias
			"return ((struct cmsghdr *)$a_c_pointer)->cmsg_level;"
		end

	c__cmsg_type (a_c_pointer: POINTER): INTEGER_32
		external
			"C inline use %"libmongo.h%""
		alias
			"return ((struct cmsghdr *)$a_c_pointer)->cmsg_type;"
		end

	c__cmsg_data (a_c_pointer: POINTER): POINTER
		external
			"C inline use %"libmongo.h%""
		alias
			"return (EIF_POINTER)((struct cmsghdr *)$a_c_pointer)->__cmsg_data;"
		end

	c__set_cmsg_len (a_c_pointer: POINTER; a_cmsg_len: NATURAL_32)
		external
			"C inline use %"libmongo.h%""
		alias
			"((struct cmsghdr *)$a_c_pointer)->cmsg_len = $a_cmsg_len;"
		end

	c__set_cmsg_level (a_c_pointer: POINTER; a_cmsg_level: INTEGER_32)
		external
			"C inline use %"libmongo.h%""
		alias
			"((struct cmsghdr *)$a_c_pointer)->cmsg_level = $a_cmsg_level;"
		end

	c__set_cmsg_type (a_c_pointer: POINTER; a_cmsg_type: INTEGER_32)
		external
			"C inline use %"libmongo.h%""
		alias
			"((struct cmsghdr *)$a_c_pointer)->cmsg_type = $a_cmsg_type;"
		end

	c__offset_of (a_field_name: POINTER): INTEGER_32
		external
			"C inline use %"libmongo.h%", <string.h>, <stddef.h>, <stdio.h>"
		alias
			"[
				if(strcmp($a_field_name, "cmsg_len") == 0) return offsetof(struct cmsghdr, cmsg_len);
				if(strcmp($a_field_name, "cmsg_level") == 0) return offsetof(struct cmsghdr, cmsg_level);
				if(strcmp($a_field_name, "cmsg_type") == 0) return offsetof(struct cmsghdr, cmsg_type);
				if(strcmp($a_field_name, "cmsg_data") == 0) return offsetof(struct cmsghdr, __cmsg_data);
				fprintf(stderr, "struct cmsghdr.%s not found\n", (char *)$a_field_name);
				return -1;
			]"
		end

end
