class
	SD_IO_FILE

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			make_shared,
			structure_size,
			offset_of,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			internal_c_pointer := internal_c_pointer.memory_alloc (structure_size)
			is_allocated_memory := True
		end

	make_shared (a_c_pointer: POINTER)
		do
			internal_c_pointer := a_c_pointer
		end

	make_initialized (a_data: TUPLE [
				a_flags: INTEGER_32
				a_io_read_ptr: CE_POINTER [INTEGER_8]
				a_io_read_end: CE_POINTER [INTEGER_8]
				a_io_read_base: CE_POINTER [INTEGER_8]
				a_io_write_base: CE_POINTER [INTEGER_8]
				a_io_write_ptr: CE_POINTER [INTEGER_8]
				a_io_write_end: CE_POINTER [INTEGER_8]
				a_io_buf_base: CE_POINTER [INTEGER_8]
				a_io_buf_end: CE_POINTER [INTEGER_8]
				a_io_save_base: CE_POINTER [INTEGER_8]
				a_io_backup_base: CE_POINTER [INTEGER_8]
				a_io_save_end: CE_POINTER [INTEGER_8]
				a_markers: CE_POINTER [SD_IO_MARKER]
				a_chain: CE_POINTER [SD_IO_FILE]
				a_fileno: INTEGER_32
				a_flags2: INTEGER_32
				a_old_offset: INTEGER_32
				a_cur_column: NATURAL_16
				a_vtable_offset: INTEGER_8
				a_shortbuf: CE_ARRAY [INTEGER_8]
				a_lock: CE_POINTER [ANY]
				a_offset: INTEGER_64
				a_pad1: CE_POINTER [ANY]
				a_pad2: CE_POINTER [ANY]
				a_pad3: CE_POINTER [ANY]
				a_pad4: CE_POINTER [ANY]
				a_pad5: NATURAL_32
				a_mode: INTEGER_32
				a_unused2: CE_ARRAY [INTEGER_8]
			])
		require else
			a_data /= Void
		do
			make
			Current.flags := a_data.a_flags
			Current.io_read_ptr := a_data.a_io_read_ptr
			Current.io_read_end := a_data.a_io_read_end
			Current.io_read_base := a_data.a_io_read_base
			Current.io_write_base := a_data.a_io_write_base
			Current.io_write_ptr := a_data.a_io_write_ptr
			Current.io_write_end := a_data.a_io_write_end
			Current.io_buf_base := a_data.a_io_buf_base
			Current.io_buf_end := a_data.a_io_buf_end
			Current.io_save_base := a_data.a_io_save_base
			Current.io_backup_base := a_data.a_io_backup_base
			Current.io_save_end := a_data.a_io_save_end
			Current.markers := a_data.a_markers
			Current.chain := a_data.a_chain
			Current.fileno := a_data.a_fileno
			Current.flags2 := a_data.a_flags2
			Current.old_offset := a_data.a_old_offset
			Current.cur_column := a_data.a_cur_column
			Current.vtable_offset := a_data.a_vtable_offset
			shortbuf.c_pointer.memory_copy (a_data.a_shortbuf.c_pointer, a_data.a_shortbuf.total_count * a_data.a_shortbuf.element_size)
			Current.lock := a_data.a_lock
			Current.offset := a_data.a_offset
			Current.pad1 := a_data.a_pad1
			Current.pad2 := a_data.a_pad2
			Current.pad3 := a_data.a_pad3
			Current.pad4 := a_data.a_pad4
			Current.pad5 := a_data.a_pad5
			Current.mode := a_data.a_mode
			unused2.c_pointer.memory_copy (a_data.a_unused2.c_pointer, a_data.a_unused2.total_count * a_data.a_unused2.element_size)
		end

feature {ANY} -- fields

	flags: INTEGER_32 assign set__flags
		do
			Result := c__flags (internal_c_pointer)
		end

	io_read_ptr: CE_POINTER [INTEGER_8] assign set__io_read_ptr
		do
			create {CE_INTEGER_8_POINTER} Result.make_shared (c__io_read_ptr (internal_c_pointer))
		end

	io_read_end: CE_POINTER [INTEGER_8] assign set__io_read_end
		do
			create {CE_INTEGER_8_POINTER} Result.make_shared (c__io_read_end (internal_c_pointer))
		end

	io_read_base: CE_POINTER [INTEGER_8] assign set__io_read_base
		do
			create {CE_INTEGER_8_POINTER} Result.make_shared (c__io_read_base (internal_c_pointer))
		end

	io_write_base: CE_POINTER [INTEGER_8] assign set__io_write_base
		do
			create {CE_INTEGER_8_POINTER} Result.make_shared (c__io_write_base (internal_c_pointer))
		end

	io_write_ptr: CE_POINTER [INTEGER_8] assign set__io_write_ptr
		do
			create {CE_INTEGER_8_POINTER} Result.make_shared (c__io_write_ptr (internal_c_pointer))
		end

	io_write_end: CE_POINTER [INTEGER_8] assign set__io_write_end
		do
			create {CE_INTEGER_8_POINTER} Result.make_shared (c__io_write_end (internal_c_pointer))
		end

	io_buf_base: CE_POINTER [INTEGER_8] assign set__io_buf_base
		do
			create {CE_INTEGER_8_POINTER} Result.make_shared (c__io_buf_base (internal_c_pointer))
		end

	io_buf_end: CE_POINTER [INTEGER_8] assign set__io_buf_end
		do
			create {CE_INTEGER_8_POINTER} Result.make_shared (c__io_buf_end (internal_c_pointer))
		end

	io_save_base: CE_POINTER [INTEGER_8] assign set__io_save_base
		do
			create {CE_INTEGER_8_POINTER} Result.make_shared (c__io_save_base (internal_c_pointer))
		end

	io_backup_base: CE_POINTER [INTEGER_8] assign set__io_backup_base
		do
			create {CE_INTEGER_8_POINTER} Result.make_shared (c__io_backup_base (internal_c_pointer))
		end

	io_save_end: CE_POINTER [INTEGER_8] assign set__io_save_end
		do
			create {CE_INTEGER_8_POINTER} Result.make_shared (c__io_save_end (internal_c_pointer))
		end

	markers: CE_POINTER [SD_IO_MARKER] assign set__markers
		do
			create {CE_CLASS_POINTER [SD_IO_MARKER]} Result.make_shared (c__markers (internal_c_pointer))
		end

	chain: CE_POINTER [SD_IO_FILE] assign set__chain
		do
			create {CE_CLASS_POINTER [SD_IO_FILE]} Result.make_shared (c__chain (internal_c_pointer))
		end

	fileno: INTEGER_32 assign set__fileno
		do
			Result := c__fileno (internal_c_pointer)
		end

	flags2: INTEGER_32 assign set__flags2
		do
			Result := c__flags2 (internal_c_pointer)
		end

	old_offset: INTEGER_32 assign set__old_offset
		do
			Result := c__old_offset (internal_c_pointer)
		end

	cur_column: NATURAL_16 assign set__cur_column
		do
			Result := c__cur_column (internal_c_pointer)
		end

	vtable_offset: INTEGER_8 assign set__vtable_offset
		do
			Result := c__vtable_offset (internal_c_pointer)
		end

	shortbuf: CE_ARRAY [INTEGER_8]
		once ("OBJECT")
			create {CE_INTEGER_8_ARRAY} Result.make_shared (c__shortbuf (internal_c_pointer), <<1>>)
		end

	lock: CE_POINTER [ANY] assign set__lock
		do
			create {CE_VOID_POINTER} Result.make_shared (c__lock (internal_c_pointer))
		end

	offset: INTEGER_64 assign set__offset
		do
			Result := c__offset (internal_c_pointer)
		end

	pad1: CE_POINTER [ANY] assign set__pad1
		do
			create {CE_VOID_POINTER} Result.make_shared (c__pad1 (internal_c_pointer))
		end

	pad2: CE_POINTER [ANY] assign set__pad2
		do
			create {CE_VOID_POINTER} Result.make_shared (c__pad2 (internal_c_pointer))
		end

	pad3: CE_POINTER [ANY] assign set__pad3
		do
			create {CE_VOID_POINTER} Result.make_shared (c__pad3 (internal_c_pointer))
		end

	pad4: CE_POINTER [ANY] assign set__pad4
		do
			create {CE_VOID_POINTER} Result.make_shared (c__pad4 (internal_c_pointer))
		end

	pad5: NATURAL_32 assign set__pad5
		do
			Result := c__pad5 (internal_c_pointer)
		end

	mode: INTEGER_32 assign set__mode
		do
			Result := c__mode (internal_c_pointer)
		end

	unused2: CE_ARRAY [INTEGER_8]
		once ("OBJECT")
			create {CE_INTEGER_8_ARRAY} Result.make_shared (c__unused2 (internal_c_pointer), <<(({NATURAL_32} 15 * {PLATFORM}.Integer_32_bytes.to_natural_32 - {NATURAL_32} 4 * {PLATFORM}.Pointer_bytes.to_natural_32) - {PLATFORM}.Natural_32_bytes.to_natural_32).to_integer_32>>)
		end

feature {ANY} -- field setters

	set__flags (a_flags: INTEGER_32)
		do
			c__set_flags (internal_c_pointer, a_flags)
		end

	set__io_read_ptr (a_io_read_ptr: CE_POINTER [INTEGER_8])
		do
			c__set_io_read_ptr (internal_c_pointer, a_io_read_ptr.c_pointer)
		end

	set__io_read_end (a_io_read_end: CE_POINTER [INTEGER_8])
		do
			c__set_io_read_end (internal_c_pointer, a_io_read_end.c_pointer)
		end

	set__io_read_base (a_io_read_base: CE_POINTER [INTEGER_8])
		do
			c__set_io_read_base (internal_c_pointer, a_io_read_base.c_pointer)
		end

	set__io_write_base (a_io_write_base: CE_POINTER [INTEGER_8])
		do
			c__set_io_write_base (internal_c_pointer, a_io_write_base.c_pointer)
		end

	set__io_write_ptr (a_io_write_ptr: CE_POINTER [INTEGER_8])
		do
			c__set_io_write_ptr (internal_c_pointer, a_io_write_ptr.c_pointer)
		end

	set__io_write_end (a_io_write_end: CE_POINTER [INTEGER_8])
		do
			c__set_io_write_end (internal_c_pointer, a_io_write_end.c_pointer)
		end

	set__io_buf_base (a_io_buf_base: CE_POINTER [INTEGER_8])
		do
			c__set_io_buf_base (internal_c_pointer, a_io_buf_base.c_pointer)
		end

	set__io_buf_end (a_io_buf_end: CE_POINTER [INTEGER_8])
		do
			c__set_io_buf_end (internal_c_pointer, a_io_buf_end.c_pointer)
		end

	set__io_save_base (a_io_save_base: CE_POINTER [INTEGER_8])
		do
			c__set_io_save_base (internal_c_pointer, a_io_save_base.c_pointer)
		end

	set__io_backup_base (a_io_backup_base: CE_POINTER [INTEGER_8])
		do
			c__set_io_backup_base (internal_c_pointer, a_io_backup_base.c_pointer)
		end

	set__io_save_end (a_io_save_end: CE_POINTER [INTEGER_8])
		do
			c__set_io_save_end (internal_c_pointer, a_io_save_end.c_pointer)
		end

	set__markers (a_markers: CE_POINTER [SD_IO_MARKER])
		do
			c__set_markers (internal_c_pointer, a_markers.c_pointer)
		end

	set__chain (a_chain: CE_POINTER [SD_IO_FILE])
		do
			c__set_chain (internal_c_pointer, a_chain.c_pointer)
		end

	set__fileno (a_fileno: INTEGER_32)
		do
			c__set_fileno (internal_c_pointer, a_fileno)
		end

	set__flags2 (a_flags2: INTEGER_32)
		do
			c__set_flags2 (internal_c_pointer, a_flags2)
		end

	set__old_offset (a_old_offset: INTEGER_32)
		do
			c__set_old_offset (internal_c_pointer, a_old_offset)
		end

	set__cur_column (a_cur_column: NATURAL_16)
		do
			c__set_cur_column (internal_c_pointer, a_cur_column)
		end

	set__vtable_offset (a_vtable_offset: INTEGER_8)
		do
			c__set_vtable_offset (internal_c_pointer, a_vtable_offset)
		end

	set__lock (a_lock: CE_POINTER [ANY])
		do
			c__set_lock (internal_c_pointer, a_lock.c_pointer)
		end

	set__offset (a_offset: INTEGER_64)
		do
			c__set_offset (internal_c_pointer, a_offset)
		end

	set__pad1 (a_pad1: CE_POINTER [ANY])
		do
			c__set_pad1 (internal_c_pointer, a_pad1.c_pointer)
		end

	set__pad2 (a_pad2: CE_POINTER [ANY])
		do
			c__set_pad2 (internal_c_pointer, a_pad2.c_pointer)
		end

	set__pad3 (a_pad3: CE_POINTER [ANY])
		do
			c__set_pad3 (internal_c_pointer, a_pad3.c_pointer)
		end

	set__pad4 (a_pad4: CE_POINTER [ANY])
		do
			c__set_pad4 (internal_c_pointer, a_pad4.c_pointer)
		end

	set__pad5 (a_pad5: NATURAL_32)
		do
			c__set_pad5 (internal_c_pointer, a_pad5)
		end

	set__mode (a_mode: INTEGER_32)
		do
			c__set_mode (internal_c_pointer, a_mode)
		end

feature {ANY}

	structure_size: INTEGER_32
		external
			"C inline use %"libmongo.h%""
		alias
			"return sizeof(struct _IO_FILE);"
		end

	structure_alignment: INTEGER_32
		external
			"C inline use %"libmongo.h%""
		alias
			"return __alignof__(struct _IO_FILE);"
		end

	offset_of (a_field_name: STRING_8): INTEGER_32
		local
			l_c_str: C_STRING
		do
			create l_c_str.make (a_field_name)
			Result := c__offset_of (l_c_str.item)
		end

feature {ANY}

	copy (a_other: like Current)
		do
			make
			internal_c_pointer.memory_copy (a_other.c_pointer, structure_size)
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result := internal_c_pointer.memory_compare (a_other.c_pointer, structure_size)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		do
			-- dummy for CE_CLASS invariant
			create Result.make_struct (<<>>)
			Result.alignment := structure_alignment
		end

	c__flags (a_c_pointer: POINTER): INTEGER_32
		external
			"C inline use %"libmongo.h%""
		alias
			"return ((struct _IO_FILE *)$a_c_pointer)->_flags;"
		end

	c__io_read_ptr (a_c_pointer: POINTER): POINTER
		external
			"C inline use %"libmongo.h%""
		alias
			"return (EIF_POINTER)((struct _IO_FILE *)$a_c_pointer)->_IO_read_ptr;"
		end

	c__io_read_end (a_c_pointer: POINTER): POINTER
		external
			"C inline use %"libmongo.h%""
		alias
			"return (EIF_POINTER)((struct _IO_FILE *)$a_c_pointer)->_IO_read_end;"
		end

	c__io_read_base (a_c_pointer: POINTER): POINTER
		external
			"C inline use %"libmongo.h%""
		alias
			"return (EIF_POINTER)((struct _IO_FILE *)$a_c_pointer)->_IO_read_base;"
		end

	c__io_write_base (a_c_pointer: POINTER): POINTER
		external
			"C inline use %"libmongo.h%""
		alias
			"return (EIF_POINTER)((struct _IO_FILE *)$a_c_pointer)->_IO_write_base;"
		end

	c__io_write_ptr (a_c_pointer: POINTER): POINTER
		external
			"C inline use %"libmongo.h%""
		alias
			"return (EIF_POINTER)((struct _IO_FILE *)$a_c_pointer)->_IO_write_ptr;"
		end

	c__io_write_end (a_c_pointer: POINTER): POINTER
		external
			"C inline use %"libmongo.h%""
		alias
			"return (EIF_POINTER)((struct _IO_FILE *)$a_c_pointer)->_IO_write_end;"
		end

	c__io_buf_base (a_c_pointer: POINTER): POINTER
		external
			"C inline use %"libmongo.h%""
		alias
			"return (EIF_POINTER)((struct _IO_FILE *)$a_c_pointer)->_IO_buf_base;"
		end

	c__io_buf_end (a_c_pointer: POINTER): POINTER
		external
			"C inline use %"libmongo.h%""
		alias
			"return (EIF_POINTER)((struct _IO_FILE *)$a_c_pointer)->_IO_buf_end;"
		end

	c__io_save_base (a_c_pointer: POINTER): POINTER
		external
			"C inline use %"libmongo.h%""
		alias
			"return (EIF_POINTER)((struct _IO_FILE *)$a_c_pointer)->_IO_save_base;"
		end

	c__io_backup_base (a_c_pointer: POINTER): POINTER
		external
			"C inline use %"libmongo.h%""
		alias
			"return (EIF_POINTER)((struct _IO_FILE *)$a_c_pointer)->_IO_backup_base;"
		end

	c__io_save_end (a_c_pointer: POINTER): POINTER
		external
			"C inline use %"libmongo.h%""
		alias
			"return (EIF_POINTER)((struct _IO_FILE *)$a_c_pointer)->_IO_save_end;"
		end

	c__markers (a_c_pointer: POINTER): POINTER
		external
			"C inline use %"libmongo.h%""
		alias
			"return (EIF_POINTER)((struct _IO_FILE *)$a_c_pointer)->_markers;"
		end

	c__chain (a_c_pointer: POINTER): POINTER
		external
			"C inline use %"libmongo.h%""
		alias
			"return (EIF_POINTER)((struct _IO_FILE *)$a_c_pointer)->_chain;"
		end

	c__fileno (a_c_pointer: POINTER): INTEGER_32
		external
			"C inline use %"libmongo.h%""
		alias
			"return ((struct _IO_FILE *)$a_c_pointer)->_fileno;"
		end

	c__flags2 (a_c_pointer: POINTER): INTEGER_32
		external
			"C inline use %"libmongo.h%""
		alias
			"return ((struct _IO_FILE *)$a_c_pointer)->_flags2;"
		end

	c__old_offset (a_c_pointer: POINTER): INTEGER_32
		external
			"C inline use %"libmongo.h%""
		alias
			"return ((struct _IO_FILE *)$a_c_pointer)->_old_offset;"
		end

	c__cur_column (a_c_pointer: POINTER): NATURAL_16
		external
			"C inline use %"libmongo.h%""
		alias
			"return ((struct _IO_FILE *)$a_c_pointer)->_cur_column;"
		end

	c__vtable_offset (a_c_pointer: POINTER): INTEGER_8
		external
			"C inline use %"libmongo.h%""
		alias
			"return ((struct _IO_FILE *)$a_c_pointer)->_vtable_offset;"
		end

	c__shortbuf (a_c_pointer: POINTER): POINTER
		external
			"C inline use %"libmongo.h%""
		alias
			"return (EIF_POINTER)((struct _IO_FILE *)$a_c_pointer)->_shortbuf;"
		end

	c__lock (a_c_pointer: POINTER): POINTER
		external
			"C inline use %"libmongo.h%""
		alias
			"return (EIF_POINTER)((struct _IO_FILE *)$a_c_pointer)->_lock;"
		end

	c__offset (a_c_pointer: POINTER): INTEGER_64
		external
			"C inline use %"libmongo.h%""
		alias
			"return ((struct _IO_FILE *)$a_c_pointer)->_offset;"
		end

	c__pad1 (a_c_pointer: POINTER): POINTER
		external
			"C inline use %"libmongo.h%""
		alias
			"return (EIF_POINTER)((struct _IO_FILE *)$a_c_pointer)->__pad1;"
		end

	c__pad2 (a_c_pointer: POINTER): POINTER
		external
			"C inline use %"libmongo.h%""
		alias
			"return (EIF_POINTER)((struct _IO_FILE *)$a_c_pointer)->__pad2;"
		end

	c__pad3 (a_c_pointer: POINTER): POINTER
		external
			"C inline use %"libmongo.h%""
		alias
			"return (EIF_POINTER)((struct _IO_FILE *)$a_c_pointer)->__pad3;"
		end

	c__pad4 (a_c_pointer: POINTER): POINTER
		external
			"C inline use %"libmongo.h%""
		alias
			"return (EIF_POINTER)((struct _IO_FILE *)$a_c_pointer)->__pad4;"
		end

	c__pad5 (a_c_pointer: POINTER): NATURAL_32
		external
			"C inline use %"libmongo.h%""
		alias
			"return ((struct _IO_FILE *)$a_c_pointer)->__pad5;"
		end

	c__mode (a_c_pointer: POINTER): INTEGER_32
		external
			"C inline use %"libmongo.h%""
		alias
			"return ((struct _IO_FILE *)$a_c_pointer)->_mode;"
		end

	c__unused2 (a_c_pointer: POINTER): POINTER
		external
			"C inline use %"libmongo.h%""
		alias
			"return (EIF_POINTER)((struct _IO_FILE *)$a_c_pointer)->_unused2;"
		end

	c__set_flags (a_c_pointer: POINTER; a_flags: INTEGER_32)
		external
			"C inline use %"libmongo.h%""
		alias
			"((struct _IO_FILE *)$a_c_pointer)->_flags = $a_flags;"
		end

	c__set_io_read_ptr (a_c_pointer: POINTER; a_io_read_ptr: POINTER)
		external
			"C inline use %"libmongo.h%""
		alias
			"((struct _IO_FILE *)$a_c_pointer)->_IO_read_ptr = $a_io_read_ptr;"
		end

	c__set_io_read_end (a_c_pointer: POINTER; a_io_read_end: POINTER)
		external
			"C inline use %"libmongo.h%""
		alias
			"((struct _IO_FILE *)$a_c_pointer)->_IO_read_end = $a_io_read_end;"
		end

	c__set_io_read_base (a_c_pointer: POINTER; a_io_read_base: POINTER)
		external
			"C inline use %"libmongo.h%""
		alias
			"((struct _IO_FILE *)$a_c_pointer)->_IO_read_base = $a_io_read_base;"
		end

	c__set_io_write_base (a_c_pointer: POINTER; a_io_write_base: POINTER)
		external
			"C inline use %"libmongo.h%""
		alias
			"((struct _IO_FILE *)$a_c_pointer)->_IO_write_base = $a_io_write_base;"
		end

	c__set_io_write_ptr (a_c_pointer: POINTER; a_io_write_ptr: POINTER)
		external
			"C inline use %"libmongo.h%""
		alias
			"((struct _IO_FILE *)$a_c_pointer)->_IO_write_ptr = $a_io_write_ptr;"
		end

	c__set_io_write_end (a_c_pointer: POINTER; a_io_write_end: POINTER)
		external
			"C inline use %"libmongo.h%""
		alias
			"((struct _IO_FILE *)$a_c_pointer)->_IO_write_end = $a_io_write_end;"
		end

	c__set_io_buf_base (a_c_pointer: POINTER; a_io_buf_base: POINTER)
		external
			"C inline use %"libmongo.h%""
		alias
			"((struct _IO_FILE *)$a_c_pointer)->_IO_buf_base = $a_io_buf_base;"
		end

	c__set_io_buf_end (a_c_pointer: POINTER; a_io_buf_end: POINTER)
		external
			"C inline use %"libmongo.h%""
		alias
			"((struct _IO_FILE *)$a_c_pointer)->_IO_buf_end = $a_io_buf_end;"
		end

	c__set_io_save_base (a_c_pointer: POINTER; a_io_save_base: POINTER)
		external
			"C inline use %"libmongo.h%""
		alias
			"((struct _IO_FILE *)$a_c_pointer)->_IO_save_base = $a_io_save_base;"
		end

	c__set_io_backup_base (a_c_pointer: POINTER; a_io_backup_base: POINTER)
		external
			"C inline use %"libmongo.h%""
		alias
			"((struct _IO_FILE *)$a_c_pointer)->_IO_backup_base = $a_io_backup_base;"
		end

	c__set_io_save_end (a_c_pointer: POINTER; a_io_save_end: POINTER)
		external
			"C inline use %"libmongo.h%""
		alias
			"((struct _IO_FILE *)$a_c_pointer)->_IO_save_end = $a_io_save_end;"
		end

	c__set_markers (a_c_pointer: POINTER; a_markers: POINTER)
		external
			"C inline use %"libmongo.h%""
		alias
			"((struct _IO_FILE *)$a_c_pointer)->_markers = $a_markers;"
		end

	c__set_chain (a_c_pointer: POINTER; a_chain: POINTER)
		external
			"C inline use %"libmongo.h%""
		alias
			"((struct _IO_FILE *)$a_c_pointer)->_chain = $a_chain;"
		end

	c__set_fileno (a_c_pointer: POINTER; a_fileno: INTEGER_32)
		external
			"C inline use %"libmongo.h%""
		alias
			"((struct _IO_FILE *)$a_c_pointer)->_fileno = $a_fileno;"
		end

	c__set_flags2 (a_c_pointer: POINTER; a_flags2: INTEGER_32)
		external
			"C inline use %"libmongo.h%""
		alias
			"((struct _IO_FILE *)$a_c_pointer)->_flags2 = $a_flags2;"
		end

	c__set_old_offset (a_c_pointer: POINTER; a_old_offset: INTEGER_32)
		external
			"C inline use %"libmongo.h%""
		alias
			"((struct _IO_FILE *)$a_c_pointer)->_old_offset = $a_old_offset;"
		end

	c__set_cur_column (a_c_pointer: POINTER; a_cur_column: NATURAL_16)
		external
			"C inline use %"libmongo.h%""
		alias
			"((struct _IO_FILE *)$a_c_pointer)->_cur_column = $a_cur_column;"
		end

	c__set_vtable_offset (a_c_pointer: POINTER; a_vtable_offset: INTEGER_8)
		external
			"C inline use %"libmongo.h%""
		alias
			"((struct _IO_FILE *)$a_c_pointer)->_vtable_offset = $a_vtable_offset;"
		end

	c__set_lock (a_c_pointer: POINTER; a_lock: POINTER)
		external
			"C inline use %"libmongo.h%""
		alias
			"((struct _IO_FILE *)$a_c_pointer)->_lock = $a_lock;"
		end

	c__set_offset (a_c_pointer: POINTER; a_offset: INTEGER_64)
		external
			"C inline use %"libmongo.h%""
		alias
			"((struct _IO_FILE *)$a_c_pointer)->_offset = $a_offset;"
		end

	c__set_pad1 (a_c_pointer: POINTER; a_pad1: POINTER)
		external
			"C inline use %"libmongo.h%""
		alias
			"((struct _IO_FILE *)$a_c_pointer)->__pad1 = $a_pad1;"
		end

	c__set_pad2 (a_c_pointer: POINTER; a_pad2: POINTER)
		external
			"C inline use %"libmongo.h%""
		alias
			"((struct _IO_FILE *)$a_c_pointer)->__pad2 = $a_pad2;"
		end

	c__set_pad3 (a_c_pointer: POINTER; a_pad3: POINTER)
		external
			"C inline use %"libmongo.h%""
		alias
			"((struct _IO_FILE *)$a_c_pointer)->__pad3 = $a_pad3;"
		end

	c__set_pad4 (a_c_pointer: POINTER; a_pad4: POINTER)
		external
			"C inline use %"libmongo.h%""
		alias
			"((struct _IO_FILE *)$a_c_pointer)->__pad4 = $a_pad4;"
		end

	c__set_pad5 (a_c_pointer: POINTER; a_pad5: NATURAL_32)
		external
			"C inline use %"libmongo.h%""
		alias
			"((struct _IO_FILE *)$a_c_pointer)->__pad5 = $a_pad5;"
		end

	c__set_mode (a_c_pointer: POINTER; a_mode: INTEGER_32)
		external
			"C inline use %"libmongo.h%""
		alias
			"((struct _IO_FILE *)$a_c_pointer)->_mode = $a_mode;"
		end

	c__offset_of (a_field_name: POINTER): INTEGER_32
		external
			"C inline use %"libmongo.h%", <string.h>, <stddef.h>, <stdio.h>"
		alias
			"[
				if(strcmp($a_field_name, "flags") == 0) return offsetof(struct _IO_FILE, _flags);
				if(strcmp($a_field_name, "io_read_ptr") == 0) return offsetof(struct _IO_FILE, _IO_read_ptr);
				if(strcmp($a_field_name, "io_read_end") == 0) return offsetof(struct _IO_FILE, _IO_read_end);
				if(strcmp($a_field_name, "io_read_base") == 0) return offsetof(struct _IO_FILE, _IO_read_base);
				if(strcmp($a_field_name, "io_write_base") == 0) return offsetof(struct _IO_FILE, _IO_write_base);
				if(strcmp($a_field_name, "io_write_ptr") == 0) return offsetof(struct _IO_FILE, _IO_write_ptr);
				if(strcmp($a_field_name, "io_write_end") == 0) return offsetof(struct _IO_FILE, _IO_write_end);
				if(strcmp($a_field_name, "io_buf_base") == 0) return offsetof(struct _IO_FILE, _IO_buf_base);
				if(strcmp($a_field_name, "io_buf_end") == 0) return offsetof(struct _IO_FILE, _IO_buf_end);
				if(strcmp($a_field_name, "io_save_base") == 0) return offsetof(struct _IO_FILE, _IO_save_base);
				if(strcmp($a_field_name, "io_backup_base") == 0) return offsetof(struct _IO_FILE, _IO_backup_base);
				if(strcmp($a_field_name, "io_save_end") == 0) return offsetof(struct _IO_FILE, _IO_save_end);
				if(strcmp($a_field_name, "markers") == 0) return offsetof(struct _IO_FILE, _markers);
				if(strcmp($a_field_name, "chain") == 0) return offsetof(struct _IO_FILE, _chain);
				if(strcmp($a_field_name, "fileno") == 0) return offsetof(struct _IO_FILE, _fileno);
				if(strcmp($a_field_name, "flags2") == 0) return offsetof(struct _IO_FILE, _flags2);
				if(strcmp($a_field_name, "old_offset") == 0) return offsetof(struct _IO_FILE, _old_offset);
				if(strcmp($a_field_name, "cur_column") == 0) return offsetof(struct _IO_FILE, _cur_column);
				if(strcmp($a_field_name, "vtable_offset") == 0) return offsetof(struct _IO_FILE, _vtable_offset);
				if(strcmp($a_field_name, "shortbuf") == 0) return offsetof(struct _IO_FILE, _shortbuf);
				if(strcmp($a_field_name, "lock") == 0) return offsetof(struct _IO_FILE, _lock);
				if(strcmp($a_field_name, "offset") == 0) return offsetof(struct _IO_FILE, _offset);
				if(strcmp($a_field_name, "pad1") == 0) return offsetof(struct _IO_FILE, __pad1);
				if(strcmp($a_field_name, "pad2") == 0) return offsetof(struct _IO_FILE, __pad2);
				if(strcmp($a_field_name, "pad3") == 0) return offsetof(struct _IO_FILE, __pad3);
				if(strcmp($a_field_name, "pad4") == 0) return offsetof(struct _IO_FILE, __pad4);
				if(strcmp($a_field_name, "pad5") == 0) return offsetof(struct _IO_FILE, __pad5);
				if(strcmp($a_field_name, "mode") == 0) return offsetof(struct _IO_FILE, _mode);
				if(strcmp($a_field_name, "unused2") == 0) return offsetof(struct _IO_FILE, _unused2);
				fprintf(stderr, "struct _IO_FILE.%s not found\n", (char *)$a_field_name);
				return -1;
			]"
		end

end
