class
	SD_MSGHDR

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			make_shared,
			structure_size,
			offset_of,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			internal_c_pointer := internal_c_pointer.memory_alloc (structure_size)
			is_allocated_memory := True
		end

	make_shared (a_c_pointer: POINTER)
		do
			internal_c_pointer := a_c_pointer
		end

	make_initialized (a_data: TUPLE [
				a_msg_name: CE_POINTER [ANY]
				a_msg_namelen: NATURAL_32
				a_msg_iov: CE_POINTER [SD_IOVEC]
				a_msg_iovlen: NATURAL_32
				a_msg_control: CE_POINTER [ANY]
				a_msg_controllen: NATURAL_32
				a_msg_flags: INTEGER_32
			])
		require else
			a_data /= Void
		do
			make
			Current.msg_name := a_data.a_msg_name
			Current.msg_namelen := a_data.a_msg_namelen
			Current.msg_iov := a_data.a_msg_iov
			Current.msg_iovlen := a_data.a_msg_iovlen
			Current.msg_control := a_data.a_msg_control
			Current.msg_controllen := a_data.a_msg_controllen
			Current.msg_flags := a_data.a_msg_flags
		end

feature {ANY} -- fields

	msg_name: CE_POINTER [ANY] assign set__msg_name
		do
			create {CE_VOID_POINTER} Result.make_shared (c__msg_name (internal_c_pointer))
		end

	msg_namelen: NATURAL_32 assign set__msg_namelen
		do
			Result := c__msg_namelen (internal_c_pointer)
		end

	msg_iov: CE_POINTER [SD_IOVEC] assign set__msg_iov
		do
			create {CE_CLASS_POINTER [SD_IOVEC]} Result.make_shared (c__msg_iov (internal_c_pointer))
		end

	msg_iovlen: NATURAL_32 assign set__msg_iovlen
		do
			Result := c__msg_iovlen (internal_c_pointer)
		end

	msg_control: CE_POINTER [ANY] assign set__msg_control
		do
			create {CE_VOID_POINTER} Result.make_shared (c__msg_control (internal_c_pointer))
		end

	msg_controllen: NATURAL_32 assign set__msg_controllen
		do
			Result := c__msg_controllen (internal_c_pointer)
		end

	msg_flags: INTEGER_32 assign set__msg_flags
		do
			Result := c__msg_flags (internal_c_pointer)
		end

feature {ANY} -- field setters

	set__msg_name (a_msg_name: CE_POINTER [ANY])
		do
			c__set_msg_name (internal_c_pointer, a_msg_name.c_pointer)
		end

	set__msg_namelen (a_msg_namelen: NATURAL_32)
		do
			c__set_msg_namelen (internal_c_pointer, a_msg_namelen)
		end

	set__msg_iov (a_msg_iov: CE_POINTER [SD_IOVEC])
		do
			c__set_msg_iov (internal_c_pointer, a_msg_iov.c_pointer)
		end

	set__msg_iovlen (a_msg_iovlen: NATURAL_32)
		do
			c__set_msg_iovlen (internal_c_pointer, a_msg_iovlen)
		end

	set__msg_control (a_msg_control: CE_POINTER [ANY])
		do
			c__set_msg_control (internal_c_pointer, a_msg_control.c_pointer)
		end

	set__msg_controllen (a_msg_controllen: NATURAL_32)
		do
			c__set_msg_controllen (internal_c_pointer, a_msg_controllen)
		end

	set__msg_flags (a_msg_flags: INTEGER_32)
		do
			c__set_msg_flags (internal_c_pointer, a_msg_flags)
		end

feature {ANY}

	structure_size: INTEGER_32
		external
			"C inline use %"libmongo.h%""
		alias
			"return sizeof(struct msghdr);"
		end

	structure_alignment: INTEGER_32
		external
			"C inline use %"libmongo.h%""
		alias
			"return __alignof__(struct msghdr);"
		end

	offset_of (a_field_name: STRING_8): INTEGER_32
		local
			l_c_str: C_STRING
		do
			create l_c_str.make (a_field_name)
			Result := c__offset_of (l_c_str.item)
		end

feature {ANY}

	copy (a_other: like Current)
		do
			make
			internal_c_pointer.memory_copy (a_other.c_pointer, structure_size)
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result := internal_c_pointer.memory_compare (a_other.c_pointer, structure_size)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		do
			-- dummy for CE_CLASS invariant
			create Result.make_struct (<<>>)
			Result.alignment := structure_alignment
		end

	c__msg_name (a_c_pointer: POINTER): POINTER
		external
			"C inline use %"libmongo.h%""
		alias
			"return (EIF_POINTER)((struct msghdr *)$a_c_pointer)->msg_name;"
		end

	c__msg_namelen (a_c_pointer: POINTER): NATURAL_32
		external
			"C inline use %"libmongo.h%""
		alias
			"return ((struct msghdr *)$a_c_pointer)->msg_namelen;"
		end

	c__msg_iov (a_c_pointer: POINTER): POINTER
		external
			"C inline use %"libmongo.h%""
		alias
			"return (EIF_POINTER)((struct msghdr *)$a_c_pointer)->msg_iov;"
		end

	c__msg_iovlen (a_c_pointer: POINTER): NATURAL_32
		external
			"C inline use %"libmongo.h%""
		alias
			"return ((struct msghdr *)$a_c_pointer)->msg_iovlen;"
		end

	c__msg_control (a_c_pointer: POINTER): POINTER
		external
			"C inline use %"libmongo.h%""
		alias
			"return (EIF_POINTER)((struct msghdr *)$a_c_pointer)->msg_control;"
		end

	c__msg_controllen (a_c_pointer: POINTER): NATURAL_32
		external
			"C inline use %"libmongo.h%""
		alias
			"return ((struct msghdr *)$a_c_pointer)->msg_controllen;"
		end

	c__msg_flags (a_c_pointer: POINTER): INTEGER_32
		external
			"C inline use %"libmongo.h%""
		alias
			"return ((struct msghdr *)$a_c_pointer)->msg_flags;"
		end

	c__set_msg_name (a_c_pointer: POINTER; a_msg_name: POINTER)
		external
			"C inline use %"libmongo.h%""
		alias
			"((struct msghdr *)$a_c_pointer)->msg_name = $a_msg_name;"
		end

	c__set_msg_namelen (a_c_pointer: POINTER; a_msg_namelen: NATURAL_32)
		external
			"C inline use %"libmongo.h%""
		alias
			"((struct msghdr *)$a_c_pointer)->msg_namelen = $a_msg_namelen;"
		end

	c__set_msg_iov (a_c_pointer: POINTER; a_msg_iov: POINTER)
		external
			"C inline use %"libmongo.h%""
		alias
			"((struct msghdr *)$a_c_pointer)->msg_iov = $a_msg_iov;"
		end

	c__set_msg_iovlen (a_c_pointer: POINTER; a_msg_iovlen: NATURAL_32)
		external
			"C inline use %"libmongo.h%""
		alias
			"((struct msghdr *)$a_c_pointer)->msg_iovlen = $a_msg_iovlen;"
		end

	c__set_msg_control (a_c_pointer: POINTER; a_msg_control: POINTER)
		external
			"C inline use %"libmongo.h%""
		alias
			"((struct msghdr *)$a_c_pointer)->msg_control = $a_msg_control;"
		end

	c__set_msg_controllen (a_c_pointer: POINTER; a_msg_controllen: NATURAL_32)
		external
			"C inline use %"libmongo.h%""
		alias
			"((struct msghdr *)$a_c_pointer)->msg_controllen = $a_msg_controllen;"
		end

	c__set_msg_flags (a_c_pointer: POINTER; a_msg_flags: INTEGER_32)
		external
			"C inline use %"libmongo.h%""
		alias
			"((struct msghdr *)$a_c_pointer)->msg_flags = $a_msg_flags;"
		end

	c__offset_of (a_field_name: POINTER): INTEGER_32
		external
			"C inline use %"libmongo.h%", <string.h>, <stddef.h>, <stdio.h>"
		alias
			"[
				if(strcmp($a_field_name, "msg_name") == 0) return offsetof(struct msghdr, msg_name);
				if(strcmp($a_field_name, "msg_namelen") == 0) return offsetof(struct msghdr, msg_namelen);
				if(strcmp($a_field_name, "msg_iov") == 0) return offsetof(struct msghdr, msg_iov);
				if(strcmp($a_field_name, "msg_iovlen") == 0) return offsetof(struct msghdr, msg_iovlen);
				if(strcmp($a_field_name, "msg_control") == 0) return offsetof(struct msghdr, msg_control);
				if(strcmp($a_field_name, "msg_controllen") == 0) return offsetof(struct msghdr, msg_controllen);
				if(strcmp($a_field_name, "msg_flags") == 0) return offsetof(struct msghdr, msg_flags);
				fprintf(stderr, "struct msghdr.%s not found\n", (char *)$a_field_name);
				return -1;
			]"
		end

end
