class
	PD_BSON_OID_T

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			make_shared,
			structure_size,
			offset_of,
			copy,
			is_equal
		end
	S_TIME_STATIC
		redefine
			copy,
			is_equal
		end
	S_STDLIB_STATIC
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			internal_c_pointer := internal_c_pointer.memory_alloc (structure_size)
			is_allocated_memory := True
		end

	make_shared (a_c_pointer: POINTER)
		do
			internal_c_pointer := a_c_pointer
		end

	make_initialized (a_data: TUPLE [
				a_bytes: CE_ARRAY [INTEGER_8]
				a_ints: CE_ARRAY [INTEGER_32]
			])
		require else
			a_data /= Void
		do
			make
			bytes.c_pointer.memory_copy (a_data.a_bytes.c_pointer, a_data.a_bytes.total_count * a_data.a_bytes.element_size)
			ints.c_pointer.memory_copy (a_data.a_ints.c_pointer, a_data.a_ints.total_count * a_data.a_ints.element_size)
		end

feature {ANY} -- fields

	bytes: CE_ARRAY [INTEGER_8]
		once ("OBJECT")
			create {CE_INTEGER_8_ARRAY} Result.make_shared (c__bytes (internal_c_pointer), <<12>>)
		end

	ints: CE_ARRAY [INTEGER_32]
		once ("OBJECT")
			create {CE_INTEGER_32_ARRAY} Result.make_shared (c__ints (internal_c_pointer), <<3>>)
		end

feature {PD_BSON_OID_T} -- private attributes

	incr: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			create Result.make (0)
		end

	fuzz: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			create Result.make (0)
		end

feature {ANY} -- public routines

	bson_oid_gen
		local
			l_i: CE_ARRAY [INTEGER_32]
			l_t: CE_ARRAY [INTEGER_32]
			l_tmp_0: INTEGER_32
		do
			create {CE_INTEGER_32_ARRAY} l_i.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_t.make (<<1>>)

			l_t.item := (time (create {CE_INTEGER_32_POINTER}.make_shared (default_pointer))).to_integer_32
			if (not ((create {P_SRC_BSON_STATIC}).oid_inc_func.item).is_void) then
				l_i.item := (create {P_SRC_BSON_STATIC}).oid_inc_func.item.integer_32_item ([])
			else
				l_tmp_0 := incr.item
				incr.item := incr.item + 1
				l_i.item := l_tmp_0
			end
			if not fuzz.item.to_boolean then
				if (not ((create {P_SRC_BSON_STATIC}).oid_fuzz_func.item).is_void) then
					fuzz.item := (create {P_SRC_BSON_STATIC}).oid_fuzz_func.item.integer_32_item ([])
				else
					srand ((l_t.item).to_natural_32)
					fuzz.item := rand
				end
			end
			(create {P_SRC_BSON_STATIC}).bson_swap_endian32 (create {CE_VOID_POINTER}.make_cast ((create {CE_INTEGER_32_POINTER}.make_shared (c_pointer + (create {PD_BSON_OID_T}.make).offset_of ("ints") + {PLATFORM}.Integer_32_bytes * (0)))), create {CE_VOID_POINTER}.make_cast (l_t))
			ints[1] := fuzz.item;
			(create {P_SRC_BSON_STATIC}).bson_swap_endian32 (create {CE_VOID_POINTER}.make_cast ((create {CE_INTEGER_32_POINTER}.make_shared (c_pointer + (create {PD_BSON_OID_T}.make).offset_of ("ints") + {PLATFORM}.Integer_32_bytes * (2)))), create {CE_VOID_POINTER}.make_cast (l_i))
		end

feature {ANY}

	structure_size: INTEGER_32
		external
			"C inline use %"libmongo.h%""
		alias
			"return sizeof(union __anonunion_bson_oid_t_12);"
		end

	structure_alignment: INTEGER_32
		external
			"C inline use %"libmongo.h%""
		alias
			"return __alignof__(union __anonunion_bson_oid_t_12);"
		end

	offset_of (a_field_name: STRING_8): INTEGER_32
		local
			l_c_str: C_STRING
		do
			create l_c_str.make (a_field_name)
			Result := c__offset_of (l_c_str.item)
		end

feature {ANY}

	copy (a_other: like Current)
		do
			make
			internal_c_pointer.memory_copy (a_other.c_pointer, structure_size)
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result := internal_c_pointer.memory_compare (a_other.c_pointer, structure_size)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		do
			-- dummy for CE_CLASS invariant
			create Result.make_union (<<>>)
			Result.alignment := structure_alignment
		end

	c__bytes (a_c_pointer: POINTER): POINTER
		external
			"C inline use %"libmongo.h%""
		alias
			"return (EIF_POINTER)((union __anonunion_bson_oid_t_12 *)$a_c_pointer)->bytes;"
		end

	c__ints (a_c_pointer: POINTER): POINTER
		external
			"C inline use %"libmongo.h%""
		alias
			"return (EIF_POINTER)((union __anonunion_bson_oid_t_12 *)$a_c_pointer)->ints;"
		end

	c__offset_of (a_field_name: POINTER): INTEGER_32
		external
			"C inline use %"libmongo.h%", <string.h>, <stddef.h>, <stdio.h>"
		alias
			"[
				if(strcmp($a_field_name, "bytes") == 0) return offsetof(union __anonunion_bson_oid_t_12, bytes);
				if(strcmp($a_field_name, "ints") == 0) return offsetof(union __anonunion_bson_oid_t_12, ints);
				fprintf(stderr, "union __anonunion_bson_oid_t_12.%s not found\n", (char *)$a_field_name);
				return -1;
			]"
		end

end
