class
	PD_MONGO_CURSOR

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			make_shared,
			structure_size,
			offset_of,
			copy,
			is_equal
		end
	S_STRING_STATIC
		redefine
			copy,
			is_equal
		end
	P_SRC_MONGO_STATIC
		redefine
			copy,
			is_equal
		end
	P_SRC_ENV_STATIC
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			internal_c_pointer := internal_c_pointer.memory_alloc (structure_size)
			is_allocated_memory := True
		end

	make_shared (a_c_pointer: POINTER)
		do
			internal_c_pointer := a_c_pointer
		end

	make_initialized (a_data: TUPLE [
				a_reply: CE_POINTER [PD_MONGO_REPLY]
				a_conn: CE_POINTER [PD_MONGO]
				a_ns: CE_POINTER [INTEGER_8]
				a_flags: INTEGER_32
				a_seen: INTEGER_32
				a_current2: PD_BSON
				a_err: NATURAL_32
				a_query: CE_POINTER [PD_BSON]
				a_fields: CE_POINTER [PD_BSON]
				a_options: INTEGER_32
				a_limit: INTEGER_32
				a_skip: INTEGER_32
			])
		require else
			a_data /= Void
		do
			make
			Current.reply := a_data.a_reply
			Current.conn := a_data.a_conn
			Current.ns := a_data.a_ns
			Current.flags := a_data.a_flags
			Current.seen := a_data.a_seen
			current2.c_pointer.memory_copy (a_data.a_current2.c_pointer, a_data.a_current2.structure_size)
			Current.err := a_data.a_err
			Current.query := a_data.a_query
			Current.fields := a_data.a_fields
			Current.options := a_data.a_options
			Current.limit := a_data.a_limit
			Current.skip := a_data.a_skip
		end

feature {ANY} -- fields

	reply: CE_POINTER [PD_MONGO_REPLY] assign set__reply
		do
			create {CE_CLASS_POINTER [PD_MONGO_REPLY]} Result.make_shared (c__reply (internal_c_pointer))
		end

	conn: CE_POINTER [PD_MONGO] assign set__conn
		do
			create {CE_CLASS_POINTER [PD_MONGO]} Result.make_shared (c__conn (internal_c_pointer))
		end

	ns: CE_POINTER [INTEGER_8] assign set__ns
		do
			create {CE_INTEGER_8_POINTER} Result.make_shared (c__ns (internal_c_pointer))
		end

	flags: INTEGER_32 assign set__flags
		do
			Result := c__flags (internal_c_pointer)
		end

	seen: INTEGER_32 assign set__seen
		do
			Result := c__seen (internal_c_pointer)
		end

	current2: PD_BSON assign set__current2
		once ("OBJECT")
			create Result.make_shared (c__current2 (internal_c_pointer))
		end

	err: NATURAL_32 assign set__err
		do
			Result := c__err (internal_c_pointer)
		end

	query: CE_POINTER [PD_BSON] assign set__query
		do
			create {CE_CLASS_POINTER [PD_BSON]} Result.make_shared (c__query (internal_c_pointer))
		end

	fields: CE_POINTER [PD_BSON] assign set__fields
		do
			create {CE_CLASS_POINTER [PD_BSON]} Result.make_shared (c__fields (internal_c_pointer))
		end

	options: INTEGER_32 assign set__options
		do
			Result := c__options (internal_c_pointer)
		end

	limit: INTEGER_32 assign set__limit
		do
			Result := c__limit (internal_c_pointer)
		end

	skip: INTEGER_32 assign set__skip
		do
			Result := c__skip (internal_c_pointer)
		end

feature {ANY} -- field setters

	set__reply (a_reply: CE_POINTER [PD_MONGO_REPLY])
		do
			c__set_reply (internal_c_pointer, a_reply.c_pointer)
		end

	set__conn (a_conn: CE_POINTER [PD_MONGO])
		do
			c__set_conn (internal_c_pointer, a_conn.c_pointer)
		end

	set__ns (a_ns: CE_POINTER [INTEGER_8])
		do
			c__set_ns (internal_c_pointer, a_ns.c_pointer)
		end

	set__flags (a_flags: INTEGER_32)
		do
			c__set_flags (internal_c_pointer, a_flags)
		end

	set__seen (a_seen: INTEGER_32)
		do
			c__set_seen (internal_c_pointer, a_seen)
		end

	set__current2 (a_current2: PD_BSON)
		do
			c__set_current2 (internal_c_pointer, a_current2.c_pointer)
		end

	set__err (a_err: NATURAL_32)
		do
			c__set_err (internal_c_pointer, a_err)
		end

	set__query (a_query: CE_POINTER [PD_BSON])
		do
			c__set_query (internal_c_pointer, a_query.c_pointer)
		end

	set__fields (a_fields: CE_POINTER [PD_BSON])
		do
			c__set_fields (internal_c_pointer, a_fields.c_pointer)
		end

	set__options (a_options: INTEGER_32)
		do
			c__set_options (internal_c_pointer, a_options)
		end

	set__limit (a_limit: INTEGER_32)
		do
			c__set_limit (internal_c_pointer, a_limit)
		end

	set__skip (a_skip: INTEGER_32)
		do
			c__set_skip (internal_c_pointer, a_skip)
		end

feature {ANY} -- public routines

	op_query: INTEGER_32
		local
			l_res: INTEGER_32
			l_empty: CE_ARRAY [PD_BSON]
			l_data_0: CE_POINTER [INTEGER_8]
			l_mm: CE_POINTER [PD_MONGO_MESSAGE]
			l_temp: CE_ARRAY [PD_BSON]
			l_it: CE_ARRAY [PD_BSON_ITERATOR]
			l_tmp_3: NATURAL_32
			l_tmp_4: INTEGER_32
			l_return: BOOLEAN
		do
			create {CE_CLASS_ARRAY [PD_BSON]} l_empty.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_BSON]} l_temp.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_BSON_ITERATOR]} l_it.make (<<1>>)

			conn.item.clear_errors
			if query.is_void then
				Current.query := (l_empty.item.empty)
			elseif (bson_valid ((create {CE_CLASS_POINTER [PD_MONGO_CURSOR]}.make_shared (c_pointer)), query)) /= 0 then
				Result := (-1)
				l_return := True
			end
			if not l_return then
				if fields.is_void then
					Current.fields := (l_empty.item.empty)
				elseif (bson_valid ((create {CE_CLASS_POINTER [PD_MONGO_CURSOR]}.make_shared (c_pointer)), fields)) /= 0 then
					Result := (-1)
					l_return := True
				end
			end
			if not l_return then
				l_tmp_3 := strlen (ns)
				l_tmp_4 := (create {P_SRC_BSON_STATIC}).bson_size (query)
				l_mm := mongo_message_create ((((((({NATURAL_32} 20 + l_tmp_3) + {NATURAL_32} 1) + {NATURAL_32} 4) + {NATURAL_32} 4) + l_tmp_4.to_natural_32) + ((create {P_SRC_BSON_STATIC}).bson_size (fields)).to_natural_32).to_integer_32, 0, 0, 2_004)
				l_data_0 := create {CE_INTEGER_8_POINTER}.make_shared (l_mm.c_pointer + (create {PD_MONGO_MESSAGE}.make).offset_of ("data"))
				l_data_0 := mongo_data_append32 (l_data_0, create {CE_VOID_POINTER}.make_cast ((create {CE_INTEGER_32_POINTER}.make_shared (c_pointer + (create {PD_MONGO_CURSOR}.make).offset_of ("options")))))
				l_data_0 := mongo_data_append (l_data_0, create {CE_VOID_POINTER}.make_cast (ns), ((strlen (ns)) + {NATURAL_32} 1).to_integer_32)
				l_data_0 := mongo_data_append32 (l_data_0, create {CE_VOID_POINTER}.make_cast ((create {CE_INTEGER_32_POINTER}.make_shared (c_pointer + (create {PD_MONGO_CURSOR}.make).offset_of ("skip")))))
				l_data_0 := mongo_data_append32 (l_data_0, create {CE_VOID_POINTER}.make_cast ((create {CE_INTEGER_32_POINTER}.make_shared (c_pointer + (create {PD_MONGO_CURSOR}.make).offset_of ("limit")))))
				l_data_0 := mongo_data_append (l_data_0, create {CE_VOID_POINTER}.make_cast (query.item.data), ((create {P_SRC_BSON_STATIC}).bson_size (query)))
				if (not fields.is_void) then
					l_data_0 := mongo_data_append (l_data_0, create {CE_VOID_POINTER}.make_cast (fields.item.data), ((create {P_SRC_BSON_STATIC}).bson_size (fields)))
				end
				(create {P_SRC_BSON_STATIC}).bson_fatal_msg ((l_data_0.is_equal (create {CE_INTEGER_8_POINTER}.make_cast (l_mm) + l_mm.item.head.len)).to_integer, ce_cstring ("query building fail!"))
				l_res := mongo_message_send (conn, l_mm)
				if l_res /= 0 then
					Result := (-1)
					l_return := True
				end
			end
			if not l_return then
				l_res := mongo_read_response (conn, create {CE_POINTER_POINTER [PD_MONGO_REPLY]}.make_shared (c_pointer + (create {PD_MONGO_CURSOR}.make).offset_of ("reply")))
				if l_res /= 0 then
					Result := (-1)
					l_return := True
				end
			end
			if not l_return and then (reply.item.fields.num = 1) then
				l_temp.item.init_data (create {CE_INTEGER_8_POINTER}.make_shared (reply.c_pointer + (create {PD_MONGO_REPLY}.make).offset_of ("objs"))).do_nothing
				if (l_it.item.bson_find (l_temp, ce_cstring ("$err"))).to_boolean then
					conn.item.set_last_error (l_it, l_temp)
					Current.err := {PC_MONGO_CURSOR_ERROR_T}.Mongo_cursor_query_fail
					Result := (-1)
					l_return := True
				end
			end
			if not l_return then
				Current.seen := seen + (reply.item.fields.num)
				Current.flags := (flags).bit_or ((2))
				Result := 0
			end
		end

	get_more: INTEGER_32
		local
			l_res: INTEGER_32
			l_data_0: CE_POINTER [INTEGER_8]
			l_sl: INTEGER_32
			l_limit: CE_ARRAY [INTEGER_32]
			l_mm: CE_POINTER [PD_MONGO_MESSAGE]
			l_pos: INTEGER_32
			l_return: BOOLEAN
		do
			create {CE_INTEGER_32_ARRAY} l_limit.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not (limit > 0) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if seen >= limit then
							Current.err := {PC_MONGO_CURSOR_ERROR_T}.Mongo_cursor_exhausted
							Result := (-1)
						else
							l_pos := -1 + 3 -- goto _L
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 4
				when 3 then -- else: | _L:
						if reply.is_void then
							Current.err := {PC_MONGO_CURSOR_ERROR_T}.Mongo_cursor_invalid
							Result := (-1)
						elseif not (reply.item.fields.cursor_id).to_boolean then
							Current.err := {PC_MONGO_CURSOR_ERROR_T}.Mongo_cursor_exhausted
							Result := (-1)
						else
							l_sl := ((strlen (ns)) + {NATURAL_32} 1).to_integer_32
							l_limit.item := 0
							if limit > 0 then
								l_limit.item := limit - seen
							end
							l_mm := mongo_message_create (((20 + l_sl) + 4) + 8, 0, 0, 2_005)
							l_data_0 := create {CE_INTEGER_8_POINTER}.make_shared (l_mm.c_pointer + (create {PD_MONGO_MESSAGE}.make).offset_of ("data"))
							l_data_0 := mongo_data_append32 (l_data_0, create {CE_VOID_POINTER}.make_cast ((zero.item)))
							l_data_0 := mongo_data_append (l_data_0, create {CE_VOID_POINTER}.make_cast (ns), l_sl)
							l_data_0 := mongo_data_append32 (l_data_0, create {CE_VOID_POINTER}.make_cast (l_limit))
							l_data_0 := mongo_data_append64 (l_data_0, create {CE_VOID_POINTER}.make_cast ((create {CE_INTEGER_64_POINTER}.make_shared (reply.c_pointer + (create {PD_MONGO_REPLY}.make).offset_of ("fields") + (create {PD_MONGO_REPLY_FIELDS}.make).offset_of ("cursor_id")))));
							(create {P_SRC_BSON_STATIC}).bson_free (create {CE_VOID_POINTER}.make_cast (reply))
							l_res := mongo_message_send (conn, l_mm)
							if l_res /= 0 then
								destroy.do_nothing
								Result := (-1)
								l_return := True
							end
							if not l_return then
								l_res := mongo_read_response (conn, create {CE_POINTER_POINTER [PD_MONGO_REPLY]}.make_shared (c_pointer + (create {PD_MONGO_CURSOR}.make).offset_of ("reply")))
								if l_res /= 0 then
									destroy.do_nothing
									Result := (-1)
									l_return := True
								end
							end
							if not l_return then
								current2.data := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
								Current.seen := seen + (reply.item.fields.num)
								Result := 0
							end
						end
				when 4 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	init (a_conn: CE_POINTER [PD_MONGO]; a_ns: CE_POINTER [INTEGER_8])
		require
			not a_ns.is_void
		do
			memset (create {CE_VOID_POINTER}.make_shared (c_pointer), 0, (create {PD_MONGO_CURSOR}.make).structure_size.to_natural_32).do_nothing
			Current.conn := a_conn
			Current.ns := create {CE_INTEGER_8_POINTER}.make_cast (((create {P_SRC_BSON_STATIC}).bson_malloc (((strlen (a_ns)) + {NATURAL_32} 1).to_integer_32)))
			strncpy (ns, a_ns, (strlen (a_ns)) + {NATURAL_32} 1).do_nothing
			current2.data := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
		end

	set_query (a_query: CE_POINTER [PD_BSON])
		do
			Current.query := a_query
		end

	set_fields (a_fields: CE_POINTER [PD_BSON])
		do
			Current.fields := a_fields
		end

	set_skip (a_skip: INTEGER_32)
		do
			Current.skip := a_skip
		end

	set_limit (a_limit: INTEGER_32)
		do
			Current.limit := a_limit
		end

	set_options (a_options: INTEGER_32)
		do
			Current.options := a_options
		end

	data: CE_POINTER [INTEGER_8]
		do
			Result := (current2.data)
		end

	next: INTEGER_32
		local
			l_next_object: CE_POINTER [INTEGER_8]
			l_message_end: CE_POINTER [INTEGER_8]
			l_return: BOOLEAN
		do
			if not ((flags).bit_and (2)).to_boolean then
				if (((create {CE_CLASS_POINTER [PD_MONGO_CURSOR]}.make_shared (c_pointer))).item.op_query) /= 0 then
					Result := (-1)
					l_return := True
				end
			end
			if not l_return and then (reply.is_void) then
				Result := (-1)
				l_return := True
			end
			if not l_return and then (reply.item.fields.num = 0) then
				if (reply.item.fields.cursor_id).to_boolean then
					if (((create {CE_CLASS_POINTER [PD_MONGO_CURSOR]}.make_shared (c_pointer))).item.get_more) /= 0 then
						Result := (-1)
						l_return := True
					elseif reply.item.fields.num = 0 then
						Result := (-1)
						l_return := True
					end
				else
					Result := (-1)
					l_return := True
				end
			end
			if not l_return and then ((current2.data).is_void) then
				bson_init_finished_data (create {CE_CLASS_POINTER [PD_BSON]}.make_shared (c_pointer + (create {PD_MONGO_CURSOR}.make).offset_of ("current2")), create {CE_INTEGER_8_POINTER}.make_shared (reply.c_pointer + (create {PD_MONGO_REPLY}.make).offset_of ("objs"))).do_nothing
				Result := 0
				l_return := True
			end
			if not l_return then
				l_next_object := current2.data + ((create {P_SRC_BSON_STATIC}).bson_size ((create {CE_CLASS_POINTER [PD_BSON]}.make_shared (c_pointer + (create {PD_MONGO_CURSOR}.make).offset_of ("current2")))))
				l_message_end := create {CE_INTEGER_8_POINTER}.make_cast (reply) + reply.item.head.len
				if (l_next_object.c_pointer.to_integer_32).to_natural_32 >= (l_message_end.c_pointer.to_integer_32).to_natural_32 then
					if (((create {CE_CLASS_POINTER [PD_MONGO_CURSOR]}.make_shared (c_pointer))).item.get_more) /= 0 then
						Result := (-1)
						l_return := True
					end
					if not l_return and then (reply.item.fields.num = 0) then
						if (reply.item.fields.cursor_id).to_boolean then
							Current.err := {PC_MONGO_CURSOR_ERROR_T}.Mongo_cursor_pending
							Result := (-1)
							l_return := True
						end
					end
					if not l_return then
						bson_init_finished_data (create {CE_CLASS_POINTER [PD_BSON]}.make_shared (c_pointer + (create {PD_MONGO_CURSOR}.make).offset_of ("current2")), create {CE_INTEGER_8_POINTER}.make_shared (reply.c_pointer + (create {PD_MONGO_REPLY}.make).offset_of ("objs"))).do_nothing
					end
				else
					bson_init_finished_data (create {CE_CLASS_POINTER [PD_BSON]}.make_shared (c_pointer + (create {PD_MONGO_CURSOR}.make).offset_of ("current2")), l_next_object).do_nothing
				end
			end
			if not l_return then
				Result := 0
			end
		end

	destroy: INTEGER_32
		local
			l_result: INTEGER_32
			l_conn: CE_POINTER [PD_MONGO]
			l_mm: CE_POINTER [PD_MONGO_MESSAGE]
			l_data_0: CE_POINTER [INTEGER_8]
		do
			if not reply.is_void then
				if reply.item.fields.cursor_id.to_boolean then
					l_conn := conn
					l_mm := (mongo_message_create (32, 0, 0, 2_007))
					l_data_0 := create {CE_INTEGER_8_POINTER}.make_shared (l_mm.c_pointer + (create {PD_MONGO_MESSAGE}.make).offset_of ("data"))
					l_data_0 := mongo_data_append32 (l_data_0, create {CE_VOID_POINTER}.make_cast (zero.item))
					l_data_0 := mongo_data_append32 (l_data_0, create {CE_VOID_POINTER}.make_cast (one.item))
					l_data_0 := mongo_data_append64 (l_data_0, create {CE_VOID_POINTER}.make_cast ((create {CE_INTEGER_64_POINTER}.make_shared (reply.c_pointer + (create {PD_MONGO_REPLY}.make).offset_of ("fields") + (create {PD_MONGO_REPLY_FIELDS}.make).offset_of ("cursor_id")))))
					l_result := mongo_message_send (l_conn, l_mm)
				end
			end
			(create {P_SRC_BSON_STATIC}).bson_free (create {CE_VOID_POINTER}.make_cast (reply))
			(create {P_SRC_BSON_STATIC}).bson_free (create {CE_VOID_POINTER}.make_cast (ns))
			if flags.bit_and (1).to_boolean then
				(create {P_SRC_BSON_STATIC}).bson_free (create {CE_VOID_POINTER}.make_cast (address))
			end
			Result := l_result
		end

feature {PD_MONGO_CURSOR} -- private routines

	mongo_read_response (a_conn: CE_POINTER [PD_MONGO]; a_reply: CE_POINTER [CE_POINTER [PD_MONGO_REPLY]]): INTEGER_32
		local
			l_head: CE_ARRAY [PD_MONGO_HEADER]
			l_fields: CE_ARRAY [PD_MONGO_REPLY_FIELDS]
			l_out: CE_POINTER [PD_MONGO_REPLY]
			l_len: CE_ARRAY [NATURAL_32]
			l_res: INTEGER_32
			l_return: BOOLEAN
		do
			create {CE_CLASS_ARRAY [PD_MONGO_HEADER]} l_head.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_MONGO_REPLY_FIELDS]} l_fields.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_len.make (<<1>>)
			create {CE_CLASS_POINTER [PD_MONGO_REPLY]} l_out.make

			env_read_socket (a_conn, create {CE_VOID_POINTER}.make_cast (l_head), ((create {PD_MONGO_HEADER}.make).structure_size.to_natural_32).to_integer_32).do_nothing
			env_read_socket (a_conn, create {CE_VOID_POINTER}.make_cast (l_fields), ((create {PD_MONGO_REPLY_FIELDS}.make).structure_size.to_natural_32).to_integer_32).do_nothing
			memcpy (create {CE_VOID_POINTER}.make_cast (l_len), create {CE_VOID_POINTER}.make_cast ((create {CE_INTEGER_32_POINTER}.make_shared (l_head.item.c_pointer + (create {PD_MONGO_HEADER}.make).offset_of ("len")))), (4).to_natural_32).do_nothing
			if l_len.item < (create {PD_MONGO_HEADER}.make).structure_size.to_natural_32 + (create {PD_MONGO_REPLY_FIELDS}.make).structure_size.to_natural_32 then
				Result := 9
				l_return := True
			elseif l_len.item > {NATURAL_32} 67_108_864 then
				Result := 9
				l_return := True
			end
			if not l_return then
				l_out := create {CE_CLASS_POINTER [PD_MONGO_REPLY]}.make_cast (((create {P_SRC_BSON_STATIC}).bson_malloc ((l_len.item).to_integer_32)))
				l_out.item.head.len := (l_len.item).to_integer_32
				memcpy (create {CE_VOID_POINTER}.make_cast ((create {CE_INTEGER_32_POINTER}.make_shared (l_out.c_pointer + (create {PD_MONGO_REPLY}.make).offset_of ("head") + (create {PD_MONGO_HEADER}.make).offset_of ("id")))), create {CE_VOID_POINTER}.make_cast ((create {CE_INTEGER_32_POINTER}.make_shared (l_head.item.c_pointer + (create {PD_MONGO_HEADER}.make).offset_of ("id")))), (4).to_natural_32).do_nothing
				memcpy (create {CE_VOID_POINTER}.make_cast ((create {CE_INTEGER_32_POINTER}.make_shared (l_out.c_pointer + (create {PD_MONGO_REPLY}.make).offset_of ("head") + (create {PD_MONGO_HEADER}.make).offset_of ("response_to")))), create {CE_VOID_POINTER}.make_cast ((create {CE_INTEGER_32_POINTER}.make_shared (l_head.item.c_pointer + (create {PD_MONGO_HEADER}.make).offset_of ("response_to")))), (4).to_natural_32).do_nothing
				memcpy (create {CE_VOID_POINTER}.make_cast ((create {CE_INTEGER_32_POINTER}.make_shared (l_out.c_pointer + (create {PD_MONGO_REPLY}.make).offset_of ("head") + (create {PD_MONGO_HEADER}.make).offset_of ("op")))), create {CE_VOID_POINTER}.make_cast ((create {CE_INTEGER_32_POINTER}.make_shared (l_head.item.c_pointer + (create {PD_MONGO_HEADER}.make).offset_of ("op")))), (4).to_natural_32).do_nothing
				memcpy (create {CE_VOID_POINTER}.make_cast ((create {CE_INTEGER_32_POINTER}.make_shared (l_out.c_pointer + (create {PD_MONGO_REPLY}.make).offset_of ("fields") + (create {PD_MONGO_REPLY_FIELDS}.make).offset_of ("flag")))), create {CE_VOID_POINTER}.make_cast ((create {CE_INTEGER_32_POINTER}.make_shared (l_fields.item.c_pointer + (create {PD_MONGO_REPLY_FIELDS}.make).offset_of ("flag")))), (4).to_natural_32).do_nothing
				memcpy (create {CE_VOID_POINTER}.make_cast ((create {CE_INTEGER_64_POINTER}.make_shared (l_out.c_pointer + (create {PD_MONGO_REPLY}.make).offset_of ("fields") + (create {PD_MONGO_REPLY_FIELDS}.make).offset_of ("cursor_id")))), create {CE_VOID_POINTER}.make_cast ((create {CE_INTEGER_64_POINTER}.make_shared (l_fields.item.c_pointer + (create {PD_MONGO_REPLY_FIELDS}.make).offset_of ("cursor_id")))), (8).to_natural_32).do_nothing
				memcpy (create {CE_VOID_POINTER}.make_cast ((create {CE_INTEGER_32_POINTER}.make_shared (l_out.c_pointer + (create {PD_MONGO_REPLY}.make).offset_of ("fields") + (create {PD_MONGO_REPLY_FIELDS}.make).offset_of ("start")))), create {CE_VOID_POINTER}.make_cast ((create {CE_INTEGER_32_POINTER}.make_shared (l_fields.item.c_pointer + (create {PD_MONGO_REPLY_FIELDS}.make).offset_of ("start")))), (4).to_natural_32).do_nothing
				memcpy (create {CE_VOID_POINTER}.make_cast ((create {CE_INTEGER_32_POINTER}.make_shared (l_out.c_pointer + (create {PD_MONGO_REPLY}.make).offset_of ("fields") + (create {PD_MONGO_REPLY_FIELDS}.make).offset_of ("num")))), create {CE_VOID_POINTER}.make_cast ((create {CE_INTEGER_32_POINTER}.make_shared (l_fields.item.c_pointer + (create {PD_MONGO_REPLY_FIELDS}.make).offset_of ("num")))), (4).to_natural_32).do_nothing
				l_res := env_read_socket (a_conn, create {CE_VOID_POINTER}.make_cast ((create {CE_INTEGER_8_POINTER}.make_shared (l_out.c_pointer + (create {PD_MONGO_REPLY}.make).offset_of ("objs")))), ((l_len.item - (create {PD_MONGO_HEADER}.make).structure_size.to_natural_32) - (create {PD_MONGO_REPLY_FIELDS}.make).structure_size.to_natural_32).to_integer_32)
				if l_res /= 0 then
					(create {P_SRC_BSON_STATIC}).bson_free (create {CE_VOID_POINTER}.make_cast (l_out))
					Result := l_res
					l_return := True
				end
			end
			if not l_return then
				a_reply.item := l_out
				Result := 0
			end
		end

	bson_init_finished_data (a_b: CE_POINTER [PD_BSON]; a_data_0: CE_POINTER [INTEGER_8]): INTEGER_32
		require
			not a_b.is_void
		do
			a_b.item.init_data (a_data_0).do_nothing
			a_b.item.finished := 1
			Result := 0
		end

	bson_valid (a_cursor: CE_POINTER [PD_MONGO_CURSOR]; a_bson_0: CE_POINTER [PD_BSON]): INTEGER_32
		require
			not a_bson_0.is_void
		local
			l_return: BOOLEAN
		do
			if not (a_bson_0.item.finished).to_boolean then
				a_cursor.item.err := {PC_MONGO_CURSOR_ERROR_T}.Mongo_cursor_bson_error;
				(a_cursor.item.conn).item.err := {PC_MONGO_ERROR_T}.Mongo_bson_not_finished
				Result := (-1)
				l_return := True
			end
			if not l_return and then (((a_bson_0.item.err).bit_and (2)).to_boolean) then
				a_cursor.item.err := {PC_MONGO_CURSOR_ERROR_T}.Mongo_cursor_bson_error;
				(a_cursor.item.conn).item.err := {PC_MONGO_ERROR_T}.Mongo_bson_invalid
				Result := (-1)
				l_return := True
			end
			if not l_return then
				Result := 0
			end
		end

feature {ANY}

	structure_size: INTEGER_32
		external
			"C inline use %"libmongo.h%""
		alias
			"return sizeof(struct __anonstruct_mongo_cursor_19);"
		end

	structure_alignment: INTEGER_32
		external
			"C inline use %"libmongo.h%""
		alias
			"return __alignof__(struct __anonstruct_mongo_cursor_19);"
		end

	offset_of (a_field_name: STRING_8): INTEGER_32
		local
			l_c_str: C_STRING
		do
			create l_c_str.make (a_field_name)
			Result := c__offset_of (l_c_str.item)
		end

feature {ANY}

	copy (a_other: like Current)
		do
			make
			internal_c_pointer.memory_copy (a_other.c_pointer, structure_size)
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result := internal_c_pointer.memory_compare (a_other.c_pointer, structure_size)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		do
			-- dummy for CE_CLASS invariant
			create Result.make_struct (<<>>)
			Result.alignment := structure_alignment
		end

	c__reply (a_c_pointer: POINTER): POINTER
		external
			"C inline use %"libmongo.h%""
		alias
			"return (EIF_POINTER)((struct __anonstruct_mongo_cursor_19 *)$a_c_pointer)->reply;"
		end

	c__conn (a_c_pointer: POINTER): POINTER
		external
			"C inline use %"libmongo.h%""
		alias
			"return (EIF_POINTER)((struct __anonstruct_mongo_cursor_19 *)$a_c_pointer)->conn;"
		end

	c__ns (a_c_pointer: POINTER): POINTER
		external
			"C inline use %"libmongo.h%""
		alias
			"return (EIF_POINTER)((struct __anonstruct_mongo_cursor_19 *)$a_c_pointer)->ns;"
		end

	c__flags (a_c_pointer: POINTER): INTEGER_32
		external
			"C inline use %"libmongo.h%""
		alias
			"return ((struct __anonstruct_mongo_cursor_19 *)$a_c_pointer)->flags;"
		end

	c__seen (a_c_pointer: POINTER): INTEGER_32
		external
			"C inline use %"libmongo.h%""
		alias
			"return ((struct __anonstruct_mongo_cursor_19 *)$a_c_pointer)->seen;"
		end

	c__current2 (a_c_pointer: POINTER): POINTER
		external
			"C inline use %"libmongo.h%""
		alias
			"return (EIF_POINTER)&((struct __anonstruct_mongo_cursor_19 *)$a_c_pointer)->current;"
		end

	c__err (a_c_pointer: POINTER): NATURAL_32
		external
			"C inline use %"libmongo.h%""
		alias
			"return ((struct __anonstruct_mongo_cursor_19 *)$a_c_pointer)->err;"
		end

	c__query (a_c_pointer: POINTER): POINTER
		external
			"C inline use %"libmongo.h%""
		alias
			"return (EIF_POINTER)((struct __anonstruct_mongo_cursor_19 *)$a_c_pointer)->query;"
		end

	c__fields (a_c_pointer: POINTER): POINTER
		external
			"C inline use %"libmongo.h%""
		alias
			"return (EIF_POINTER)((struct __anonstruct_mongo_cursor_19 *)$a_c_pointer)->fields;"
		end

	c__options (a_c_pointer: POINTER): INTEGER_32
		external
			"C inline use %"libmongo.h%""
		alias
			"return ((struct __anonstruct_mongo_cursor_19 *)$a_c_pointer)->options;"
		end

	c__limit (a_c_pointer: POINTER): INTEGER_32
		external
			"C inline use %"libmongo.h%""
		alias
			"return ((struct __anonstruct_mongo_cursor_19 *)$a_c_pointer)->limit;"
		end

	c__skip (a_c_pointer: POINTER): INTEGER_32
		external
			"C inline use %"libmongo.h%""
		alias
			"return ((struct __anonstruct_mongo_cursor_19 *)$a_c_pointer)->skip;"
		end

	c__set_reply (a_c_pointer: POINTER; a_reply: POINTER)
		external
			"C inline use %"libmongo.h%""
		alias
			"((struct __anonstruct_mongo_cursor_19 *)$a_c_pointer)->reply = $a_reply;"
		end

	c__set_conn (a_c_pointer: POINTER; a_conn: POINTER)
		external
			"C inline use %"libmongo.h%""
		alias
			"((struct __anonstruct_mongo_cursor_19 *)$a_c_pointer)->conn = $a_conn;"
		end

	c__set_ns (a_c_pointer: POINTER; a_ns: POINTER)
		external
			"C inline use %"libmongo.h%""
		alias
			"((struct __anonstruct_mongo_cursor_19 *)$a_c_pointer)->ns = $a_ns;"
		end

	c__set_flags (a_c_pointer: POINTER; a_flags: INTEGER_32)
		external
			"C inline use %"libmongo.h%""
		alias
			"((struct __anonstruct_mongo_cursor_19 *)$a_c_pointer)->flags = $a_flags;"
		end

	c__set_seen (a_c_pointer: POINTER; a_seen: INTEGER_32)
		external
			"C inline use %"libmongo.h%""
		alias
			"((struct __anonstruct_mongo_cursor_19 *)$a_c_pointer)->seen = $a_seen;"
		end

	c__set_current2 (a_c_pointer: POINTER; a_current2: POINTER)
		external
			"C inline use %"libmongo.h%""
		alias
			"((struct __anonstruct_mongo_cursor_19 *)$a_c_pointer)->current = *(struct __anonstruct_bson_11 *)$a_current2;"
		end

	c__set_err (a_c_pointer: POINTER; a_err: NATURAL_32)
		external
			"C inline use %"libmongo.h%""
		alias
			"((struct __anonstruct_mongo_cursor_19 *)$a_c_pointer)->err = $a_err;"
		end

	c__set_query (a_c_pointer: POINTER; a_query: POINTER)
		external
			"C inline use %"libmongo.h%""
		alias
			"((struct __anonstruct_mongo_cursor_19 *)$a_c_pointer)->query = $a_query;"
		end

	c__set_fields (a_c_pointer: POINTER; a_fields: POINTER)
		external
			"C inline use %"libmongo.h%""
		alias
			"((struct __anonstruct_mongo_cursor_19 *)$a_c_pointer)->fields = $a_fields;"
		end

	c__set_options (a_c_pointer: POINTER; a_options: INTEGER_32)
		external
			"C inline use %"libmongo.h%""
		alias
			"((struct __anonstruct_mongo_cursor_19 *)$a_c_pointer)->options = $a_options;"
		end

	c__set_limit (a_c_pointer: POINTER; a_limit: INTEGER_32)
		external
			"C inline use %"libmongo.h%""
		alias
			"((struct __anonstruct_mongo_cursor_19 *)$a_c_pointer)->limit = $a_limit;"
		end

	c__set_skip (a_c_pointer: POINTER; a_skip: INTEGER_32)
		external
			"C inline use %"libmongo.h%""
		alias
			"((struct __anonstruct_mongo_cursor_19 *)$a_c_pointer)->skip = $a_skip;"
		end

	c__offset_of (a_field_name: POINTER): INTEGER_32
		external
			"C inline use %"libmongo.h%", <string.h>, <stddef.h>, <stdio.h>"
		alias
			"[
				if(strcmp($a_field_name, "reply") == 0) return offsetof(struct __anonstruct_mongo_cursor_19, reply);
				if(strcmp($a_field_name, "conn") == 0) return offsetof(struct __anonstruct_mongo_cursor_19, conn);
				if(strcmp($a_field_name, "ns") == 0) return offsetof(struct __anonstruct_mongo_cursor_19, ns);
				if(strcmp($a_field_name, "flags") == 0) return offsetof(struct __anonstruct_mongo_cursor_19, flags);
				if(strcmp($a_field_name, "seen") == 0) return offsetof(struct __anonstruct_mongo_cursor_19, seen);
				if(strcmp($a_field_name, "current2") == 0) return offsetof(struct __anonstruct_mongo_cursor_19, current);
				if(strcmp($a_field_name, "err") == 0) return offsetof(struct __anonstruct_mongo_cursor_19, err);
				if(strcmp($a_field_name, "query") == 0) return offsetof(struct __anonstruct_mongo_cursor_19, query);
				if(strcmp($a_field_name, "fields") == 0) return offsetof(struct __anonstruct_mongo_cursor_19, fields);
				if(strcmp($a_field_name, "options") == 0) return offsetof(struct __anonstruct_mongo_cursor_19, options);
				if(strcmp($a_field_name, "limit") == 0) return offsetof(struct __anonstruct_mongo_cursor_19, limit);
				if(strcmp($a_field_name, "skip") == 0) return offsetof(struct __anonstruct_mongo_cursor_19, skip);
				fprintf(stderr, "struct __anonstruct_mongo_cursor_19.%s not found\n", (char *)$a_field_name);
				return -1;
			]"
		end

end
