class
	PD_MONGO_HEADER

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			make_shared,
			structure_size,
			offset_of,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			internal_c_pointer := internal_c_pointer.memory_alloc (structure_size)
			is_allocated_memory := True
		end

	make_shared (a_c_pointer: POINTER)
		do
			internal_c_pointer := a_c_pointer
		end

	make_initialized (a_data: TUPLE [
				a_len: INTEGER_32
				a_id: INTEGER_32
				a_response_to: INTEGER_32
				a_op: INTEGER_32
			])
		require else
			a_data /= Void
		do
			make
			Current.len := a_data.a_len
			Current.id := a_data.a_id
			Current.response_to := a_data.a_response_to
			Current.op := a_data.a_op
		end

feature {ANY} -- fields

	len: INTEGER_32 assign set__len
		do
			Result := c__len (internal_c_pointer)
		end

	id: INTEGER_32 assign set__id
		do
			Result := c__id (internal_c_pointer)
		end

	response_to: INTEGER_32 assign set__response_to
		do
			Result := c__response_to (internal_c_pointer)
		end

	op: INTEGER_32 assign set__op
		do
			Result := c__op (internal_c_pointer)
		end

feature {ANY} -- field setters

	set__len (a_len: INTEGER_32)
		do
			c__set_len (internal_c_pointer, a_len)
		end

	set__id (a_id: INTEGER_32)
		do
			c__set_id (internal_c_pointer, a_id)
		end

	set__response_to (a_response_to: INTEGER_32)
		do
			c__set_response_to (internal_c_pointer, a_response_to)
		end

	set__op (a_op: INTEGER_32)
		do
			c__set_op (internal_c_pointer, a_op)
		end

feature {ANY}

	structure_size: INTEGER_32
		external
			"C inline use %"libmongo.h%""
		alias
			"return sizeof(struct __anonstruct_mongo_header_14);"
		end

	structure_alignment: INTEGER_32
		external
			"C inline use %"libmongo.h%""
		alias
			"return __alignof__(struct __anonstruct_mongo_header_14);"
		end

	offset_of (a_field_name: STRING_8): INTEGER_32
		local
			l_c_str: C_STRING
		do
			create l_c_str.make (a_field_name)
			Result := c__offset_of (l_c_str.item)
		end

feature {ANY}

	copy (a_other: like Current)
		do
			make
			internal_c_pointer.memory_copy (a_other.c_pointer, structure_size)
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result := internal_c_pointer.memory_compare (a_other.c_pointer, structure_size)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		do
			-- dummy for CE_CLASS invariant
			create Result.make_struct (<<>>)
			Result.alignment := structure_alignment
		end

	c__len (a_c_pointer: POINTER): INTEGER_32
		external
			"C inline use %"libmongo.h%""
		alias
			"return ((struct __anonstruct_mongo_header_14 *)$a_c_pointer)->len;"
		end

	c__id (a_c_pointer: POINTER): INTEGER_32
		external
			"C inline use %"libmongo.h%""
		alias
			"return ((struct __anonstruct_mongo_header_14 *)$a_c_pointer)->id;"
		end

	c__response_to (a_c_pointer: POINTER): INTEGER_32
		external
			"C inline use %"libmongo.h%""
		alias
			"return ((struct __anonstruct_mongo_header_14 *)$a_c_pointer)->responseTo;"
		end

	c__op (a_c_pointer: POINTER): INTEGER_32
		external
			"C inline use %"libmongo.h%""
		alias
			"return ((struct __anonstruct_mongo_header_14 *)$a_c_pointer)->op;"
		end

	c__set_len (a_c_pointer: POINTER; a_len: INTEGER_32)
		external
			"C inline use %"libmongo.h%""
		alias
			"((struct __anonstruct_mongo_header_14 *)$a_c_pointer)->len = $a_len;"
		end

	c__set_id (a_c_pointer: POINTER; a_id: INTEGER_32)
		external
			"C inline use %"libmongo.h%""
		alias
			"((struct __anonstruct_mongo_header_14 *)$a_c_pointer)->id = $a_id;"
		end

	c__set_response_to (a_c_pointer: POINTER; a_response_to: INTEGER_32)
		external
			"C inline use %"libmongo.h%""
		alias
			"((struct __anonstruct_mongo_header_14 *)$a_c_pointer)->responseTo = $a_response_to;"
		end

	c__set_op (a_c_pointer: POINTER; a_op: INTEGER_32)
		external
			"C inline use %"libmongo.h%""
		alias
			"((struct __anonstruct_mongo_header_14 *)$a_c_pointer)->op = $a_op;"
		end

	c__offset_of (a_field_name: POINTER): INTEGER_32
		external
			"C inline use %"libmongo.h%", <string.h>, <stddef.h>, <stdio.h>"
		alias
			"[
				if(strcmp($a_field_name, "len") == 0) return offsetof(struct __anonstruct_mongo_header_14, len);
				if(strcmp($a_field_name, "id") == 0) return offsetof(struct __anonstruct_mongo_header_14, id);
				if(strcmp($a_field_name, "response_to") == 0) return offsetof(struct __anonstruct_mongo_header_14, responseTo);
				if(strcmp($a_field_name, "op") == 0) return offsetof(struct __anonstruct_mongo_header_14, op);
				fprintf(stderr, "struct __anonstruct_mongo_header_14.%s not found\n", (char *)$a_field_name);
				return -1;
			]"
		end

end
