class
	PD_MONGO_REPLSET

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			make_shared,
			structure_size,
			offset_of,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			internal_c_pointer := internal_c_pointer.memory_alloc (structure_size)
			is_allocated_memory := True
		end

	make_shared (a_c_pointer: POINTER)
		do
			internal_c_pointer := a_c_pointer
		end

	make_initialized (a_data: TUPLE [
				a_seeds: CE_POINTER [PD_MONGO_HOST_PORT]
				a_hosts: CE_POINTER [PD_MONGO_HOST_PORT]
				a_name: CE_POINTER [INTEGER_8]
				a_primary_connected: INTEGER_32
			])
		require else
			a_data /= Void
		do
			make
			Current.seeds := a_data.a_seeds
			Current.hosts := a_data.a_hosts
			Current.name := a_data.a_name
			Current.primary_connected := a_data.a_primary_connected
		end

feature {ANY} -- fields

	seeds: CE_POINTER [PD_MONGO_HOST_PORT] assign set__seeds
		do
			create {CE_CLASS_POINTER [PD_MONGO_HOST_PORT]} Result.make_shared (c__seeds (internal_c_pointer))
		end

	hosts: CE_POINTER [PD_MONGO_HOST_PORT] assign set__hosts
		do
			create {CE_CLASS_POINTER [PD_MONGO_HOST_PORT]} Result.make_shared (c__hosts (internal_c_pointer))
		end

	name: CE_POINTER [INTEGER_8] assign set__name
		do
			create {CE_INTEGER_8_POINTER} Result.make_shared (c__name (internal_c_pointer))
		end

	primary_connected: INTEGER_32 assign set__primary_connected
		do
			Result := c__primary_connected (internal_c_pointer)
		end

feature {ANY} -- field setters

	set__seeds (a_seeds: CE_POINTER [PD_MONGO_HOST_PORT])
		do
			c__set_seeds (internal_c_pointer, a_seeds.c_pointer)
		end

	set__hosts (a_hosts: CE_POINTER [PD_MONGO_HOST_PORT])
		do
			c__set_hosts (internal_c_pointer, a_hosts.c_pointer)
		end

	set__name (a_name: CE_POINTER [INTEGER_8])
		do
			c__set_name (internal_c_pointer, a_name.c_pointer)
		end

	set__primary_connected (a_primary_connected: INTEGER_32)
		do
			c__set_primary_connected (internal_c_pointer, a_primary_connected)
		end

feature {ANY}

	structure_size: INTEGER_32
		external
			"C inline use %"libmongo.h%""
		alias
			"return sizeof(struct __anonstruct_mongo_replset_18);"
		end

	structure_alignment: INTEGER_32
		external
			"C inline use %"libmongo.h%""
		alias
			"return __alignof__(struct __anonstruct_mongo_replset_18);"
		end

	offset_of (a_field_name: STRING_8): INTEGER_32
		local
			l_c_str: C_STRING
		do
			create l_c_str.make (a_field_name)
			Result := c__offset_of (l_c_str.item)
		end

feature {ANY}

	copy (a_other: like Current)
		do
			make
			internal_c_pointer.memory_copy (a_other.c_pointer, structure_size)
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result := internal_c_pointer.memory_compare (a_other.c_pointer, structure_size)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		do
			-- dummy for CE_CLASS invariant
			create Result.make_struct (<<>>)
			Result.alignment := structure_alignment
		end

	c__seeds (a_c_pointer: POINTER): POINTER
		external
			"C inline use %"libmongo.h%""
		alias
			"return (EIF_POINTER)((struct __anonstruct_mongo_replset_18 *)$a_c_pointer)->seeds;"
		end

	c__hosts (a_c_pointer: POINTER): POINTER
		external
			"C inline use %"libmongo.h%""
		alias
			"return (EIF_POINTER)((struct __anonstruct_mongo_replset_18 *)$a_c_pointer)->hosts;"
		end

	c__name (a_c_pointer: POINTER): POINTER
		external
			"C inline use %"libmongo.h%""
		alias
			"return (EIF_POINTER)((struct __anonstruct_mongo_replset_18 *)$a_c_pointer)->name;"
		end

	c__primary_connected (a_c_pointer: POINTER): INTEGER_32
		external
			"C inline use %"libmongo.h%""
		alias
			"return ((struct __anonstruct_mongo_replset_18 *)$a_c_pointer)->primary_connected;"
		end

	c__set_seeds (a_c_pointer: POINTER; a_seeds: POINTER)
		external
			"C inline use %"libmongo.h%""
		alias
			"((struct __anonstruct_mongo_replset_18 *)$a_c_pointer)->seeds = $a_seeds;"
		end

	c__set_hosts (a_c_pointer: POINTER; a_hosts: POINTER)
		external
			"C inline use %"libmongo.h%""
		alias
			"((struct __anonstruct_mongo_replset_18 *)$a_c_pointer)->hosts = $a_hosts;"
		end

	c__set_name (a_c_pointer: POINTER; a_name: POINTER)
		external
			"C inline use %"libmongo.h%""
		alias
			"((struct __anonstruct_mongo_replset_18 *)$a_c_pointer)->name = $a_name;"
		end

	c__set_primary_connected (a_c_pointer: POINTER; a_primary_connected: INTEGER_32)
		external
			"C inline use %"libmongo.h%""
		alias
			"((struct __anonstruct_mongo_replset_18 *)$a_c_pointer)->primary_connected = $a_primary_connected;"
		end

	c__offset_of (a_field_name: POINTER): INTEGER_32
		external
			"C inline use %"libmongo.h%", <string.h>, <stddef.h>, <stdio.h>"
		alias
			"[
				if(strcmp($a_field_name, "seeds") == 0) return offsetof(struct __anonstruct_mongo_replset_18, seeds);
				if(strcmp($a_field_name, "hosts") == 0) return offsetof(struct __anonstruct_mongo_replset_18, hosts);
				if(strcmp($a_field_name, "name") == 0) return offsetof(struct __anonstruct_mongo_replset_18, name);
				if(strcmp($a_field_name, "primary_connected") == 0) return offsetof(struct __anonstruct_mongo_replset_18, primary_connected);
				fprintf(stderr, "struct __anonstruct_mongo_replset_18.%s not found\n", (char *)$a_field_name);
				return -1;
			]"
		end

end
