class
	S_STDIO_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public attributes

	imp_iob: CE_POINTER [CE_ARRAY [SD_IO_FILE]] assign set_imp_iob
		do
			create {CE_ARRAY_POINTER [SD_IO_FILE]} Result.make_shared (c_imp_iob)
		end

	c_imp_iob: POINTER
		external
			"C inline use <libmongo.h>"
		alias
			"return (EIF_POINTER)_imp___iob;"
		end

	set_imp_iob (a_imp_iob: CE_POINTER [CE_ARRAY [SD_IO_FILE]])
		do
			c_set_imp_iob (a_imp_iob.c_pointer)
		end

	c_set_imp_iob (a_imp_iob: POINTER)
		external
			"C inline use <libmongo.h>"
		alias
			"_imp___iob = (struct _iobuf ( *)[])$a_imp_iob;"
		end

feature {ANY} -- public routines

	fclose (a_file: CE_POINTER [SD_IO_FILE]): INTEGER_32
		do
			Result := c_fclose (a_file.c_pointer)
		end

	c_fclose (a_file: POINTER): INTEGER_32
		external
			"C inline use <libmongo.h>"
		alias
			"return fclose($a_file);"
		end

	fopen (a_filename, a_mode: CE_POINTER [INTEGER_8]): CE_POINTER [SD_IO_FILE]
		do
			create {CE_CLASS_POINTER [SD_IO_FILE]} Result.make_shared (c_fopen (a_filename.c_pointer, a_mode.c_pointer))
		end

	c_fopen (a_filename: POINTER; a_mode: POINTER): POINTER
		external
			"C inline use <libmongo.h>"
		alias
			"return (EIF_POINTER)fopen($a_filename, $a_mode);"
		end

	fread (a_dst_buf: CE_POINTER [ANY]; a_element_size, a_count: NATURAL_32; a_file: CE_POINTER [SD_IO_FILE]): NATURAL_32
		do
			Result := c_fread (a_dst_buf.c_pointer, a_element_size, a_count, a_file.c_pointer)
		end

	c_fread (a_dst_buf: POINTER; a_element_size: NATURAL_32; a_count: NATURAL_32; a_file: POINTER): NATURAL_32
		external
			"C inline use <libmongo.h>"
		alias
			"return fread($a_dst_buf, $a_element_size, $a_count, $a_file);"
		end

	fwrite (a_str: CE_POINTER [ANY]; a_size, a_count: NATURAL_32; a_file: CE_POINTER [SD_IO_FILE]): NATURAL_32
		do
			Result := c_fwrite (a_str.c_pointer, a_size, a_count, a_file.c_pointer)
		end

	c_fwrite (a_str: POINTER; a_size: NATURAL_32; a_count: NATURAL_32; a_file: POINTER): NATURAL_32
		external
			"C inline use <libmongo.h>"
		alias
			"return fwrite($a_str, $a_size, $a_count, $a_file);"
		end

	fprintf (a_args: TUPLE [a_file: CE_POINTER [SD_IO_FILE]; a_format: CE_POINTER [INTEGER_8]]): INTEGER_32
		do
			Result := (create {CE_ROUTINE}.make_shared (c_fprintf)).integer_32_item (a_args)
		end

	c_fprintf: POINTER
		external
			"C inline use <libmongo.h>"
		alias
			"return (EIF_POINTER)&fprintf;"
		end

	printf (a_args: TUPLE [a_format: CE_POINTER [INTEGER_8]]): INTEGER_32
		do
			Result := (create {CE_ROUTINE}.make_shared (c_printf)).integer_32_item (a_args)
		end

	c_printf: POINTER
		external
			"C inline use <libmongo.h>"
		alias
			"return (EIF_POINTER)&printf;"
		end

	vfprintf (a_file: CE_POINTER [SD_IO_FILE]; a_format: CE_POINTER [INTEGER_8]; a_arg_list: CE_VA_LIST): INTEGER_32
		do
			Result := c_vfprintf (a_file.c_pointer, a_format.c_pointer, a_arg_list.c_pointer)
		end

	c_vfprintf (a_file: POINTER; a_format: POINTER; a_arg_list: POINTER): INTEGER_32
		external
			"C inline use <libmongo.h>"
		alias
			"return vfprintf($a_file, $a_format, $a_arg_list);"
		end

	sprintf (a_args: TUPLE [a_dest, a_format: CE_POINTER [INTEGER_8]]): INTEGER_32
		do
			Result := (create {CE_ROUTINE}.make_shared (c_sprintf)).integer_32_item (a_args)
		end

	c_sprintf: POINTER
		external
			"C inline use <libmongo.h>"
		alias
			"return (EIF_POINTER)&sprintf;"
		end

feature {ANY} -- routine addresses

	fprintf_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_shared (c_fprintf)
		end

	printf_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_shared (c_printf)
		end

	sprintf_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_shared (c_sprintf)
		end

end
